(function(scope){
'use strict';

function F(arity, fun, wrapper) {
  wrapper.a = arity;
  wrapper.f = fun;
  return wrapper;
}

function F2(fun) {
  return F(2, fun, function(a) { return function(b) { return fun(a,b); }; })
}
function F3(fun) {
  return F(3, fun, function(a) {
    return function(b) { return function(c) { return fun(a, b, c); }; };
  });
}
function F4(fun) {
  return F(4, fun, function(a) { return function(b) { return function(c) {
    return function(d) { return fun(a, b, c, d); }; }; };
  });
}
function F5(fun) {
  return F(5, fun, function(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return fun(a, b, c, d, e); }; }; }; };
  });
}
function F6(fun) {
  return F(6, fun, function(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return function(f) {
    return fun(a, b, c, d, e, f); }; }; }; }; };
  });
}
function F7(fun) {
  return F(7, fun, function(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return function(f) {
    return function(g) { return fun(a, b, c, d, e, f, g); }; }; }; }; }; };
  });
}
function F8(fun) {
  return F(8, fun, function(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return function(f) {
    return function(g) { return function(h) {
    return fun(a, b, c, d, e, f, g, h); }; }; }; }; }; }; };
  });
}
function F9(fun) {
  return F(9, fun, function(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return function(f) {
    return function(g) { return function(h) { return function(i) {
    return fun(a, b, c, d, e, f, g, h, i); }; }; }; }; }; }; }; };
  });
}

function A2(fun, a, b) {
  return fun.a === 2 ? fun.f(a, b) : fun(a)(b);
}
function A3(fun, a, b, c) {
  return fun.a === 3 ? fun.f(a, b, c) : fun(a)(b)(c);
}
function A4(fun, a, b, c, d) {
  return fun.a === 4 ? fun.f(a, b, c, d) : fun(a)(b)(c)(d);
}
function A5(fun, a, b, c, d, e) {
  return fun.a === 5 ? fun.f(a, b, c, d, e) : fun(a)(b)(c)(d)(e);
}
function A6(fun, a, b, c, d, e, f) {
  return fun.a === 6 ? fun.f(a, b, c, d, e, f) : fun(a)(b)(c)(d)(e)(f);
}
function A7(fun, a, b, c, d, e, f, g) {
  return fun.a === 7 ? fun.f(a, b, c, d, e, f, g) : fun(a)(b)(c)(d)(e)(f)(g);
}
function A8(fun, a, b, c, d, e, f, g, h) {
  return fun.a === 8 ? fun.f(a, b, c, d, e, f, g, h) : fun(a)(b)(c)(d)(e)(f)(g)(h);
}
function A9(fun, a, b, c, d, e, f, g, h, i) {
  return fun.a === 9 ? fun.f(a, b, c, d, e, f, g, h, i) : fun(a)(b)(c)(d)(e)(f)(g)(h)(i);
}




var _List_Nil = { $: 0 };
var _List_Nil_UNUSED = { $: '[]' };

function _List_Cons(hd, tl) { return { $: 1, a: hd, b: tl }; }
function _List_Cons_UNUSED(hd, tl) { return { $: '::', a: hd, b: tl }; }


var _List_cons = F2(_List_Cons);

function _List_fromArray(arr)
{
	var out = _List_Nil;
	for (var i = arr.length; i--; )
	{
		out = _List_Cons(arr[i], out);
	}
	return out;
}

function _List_toArray(xs)
{
	for (var out = []; xs.b; xs = xs.b) // WHILE_CONS
	{
		out.push(xs.a);
	}
	return out;
}

var _List_map2 = F3(function(f, xs, ys)
{
	for (var arr = []; xs.b && ys.b; xs = xs.b, ys = ys.b) // WHILE_CONSES
	{
		arr.push(A2(f, xs.a, ys.a));
	}
	return _List_fromArray(arr);
});

var _List_map3 = F4(function(f, xs, ys, zs)
{
	for (var arr = []; xs.b && ys.b && zs.b; xs = xs.b, ys = ys.b, zs = zs.b) // WHILE_CONSES
	{
		arr.push(A3(f, xs.a, ys.a, zs.a));
	}
	return _List_fromArray(arr);
});

var _List_map4 = F5(function(f, ws, xs, ys, zs)
{
	for (var arr = []; ws.b && xs.b && ys.b && zs.b; ws = ws.b, xs = xs.b, ys = ys.b, zs = zs.b) // WHILE_CONSES
	{
		arr.push(A4(f, ws.a, xs.a, ys.a, zs.a));
	}
	return _List_fromArray(arr);
});

var _List_map5 = F6(function(f, vs, ws, xs, ys, zs)
{
	for (var arr = []; vs.b && ws.b && xs.b && ys.b && zs.b; vs = vs.b, ws = ws.b, xs = xs.b, ys = ys.b, zs = zs.b) // WHILE_CONSES
	{
		arr.push(A5(f, vs.a, ws.a, xs.a, ys.a, zs.a));
	}
	return _List_fromArray(arr);
});

var _List_sortBy = F2(function(f, xs)
{
	return _List_fromArray(_List_toArray(xs).sort(function(a, b) {
		return _Utils_cmp(f(a), f(b));
	}));
});

var _List_sortWith = F2(function(f, xs)
{
	return _List_fromArray(_List_toArray(xs).sort(function(a, b) {
		var ord = A2(f, a, b);
		return ord === elm$core$Basics$EQ ? 0 : ord === elm$core$Basics$LT ? -1 : 1;
	}));
});



// EQUALITY

function _Utils_eq(x, y)
{
	for (
		var pair, stack = [], isEqual = _Utils_eqHelp(x, y, 0, stack);
		isEqual && (pair = stack.pop());
		isEqual = _Utils_eqHelp(pair.a, pair.b, 0, stack)
		)
	{}

	return isEqual;
}

function _Utils_eqHelp(x, y, depth, stack)
{
	if (depth > 100)
	{
		stack.push(_Utils_Tuple2(x,y));
		return true;
	}

	if (x === y)
	{
		return true;
	}

	if (typeof x !== 'object' || x === null || y === null)
	{
		typeof x === 'function' && _Debug_crash(5);
		return false;
	}

	/**_UNUSED/
	if (x.$ === 'Set_elm_builtin')
	{
		x = elm$core$Set$toList(x);
		y = elm$core$Set$toList(y);
	}
	if (x.$ === 'RBNode_elm_builtin' || x.$ === 'RBEmpty_elm_builtin')
	{
		x = elm$core$Dict$toList(x);
		y = elm$core$Dict$toList(y);
	}
	//*/

	/**/
	if (x.$ < 0)
	{
		x = elm$core$Dict$toList(x);
		y = elm$core$Dict$toList(y);
	}
	//*/

	for (var key in x)
	{
		if (!_Utils_eqHelp(x[key], y[key], depth + 1, stack))
		{
			return false;
		}
	}
	return true;
}

var _Utils_equal = F2(_Utils_eq);
var _Utils_notEqual = F2(function(a, b) { return !_Utils_eq(a,b); });



// COMPARISONS

// Code in Generate/JavaScript.hs, Basics.js, and List.js depends on
// the particular integer values assigned to LT, EQ, and GT.

function _Utils_cmp(x, y, ord)
{
	if (typeof x !== 'object')
	{
		return x === y ? /*EQ*/ 0 : x < y ? /*LT*/ -1 : /*GT*/ 1;
	}

	/**_UNUSED/
	if (x instanceof String)
	{
		var a = x.valueOf();
		var b = y.valueOf();
		return a === b ? 0 : a < b ? -1 : 1;
	}
	//*/

	/**/
	if (typeof x.$ === 'undefined')
	//*/
	/**_UNUSED/
	if (x.$[0] === '#')
	//*/
	{
		return (ord = _Utils_cmp(x.a, y.a))
			? ord
			: (ord = _Utils_cmp(x.b, y.b))
				? ord
				: _Utils_cmp(x.c, y.c);
	}

	// traverse conses until end of a list or a mismatch
	for (; x.b && y.b && !(ord = _Utils_cmp(x.a, y.a)); x = x.b, y = y.b) {} // WHILE_CONSES
	return ord || (x.b ? /*GT*/ 1 : y.b ? /*LT*/ -1 : /*EQ*/ 0);
}

var _Utils_lt = F2(function(a, b) { return _Utils_cmp(a, b) < 0; });
var _Utils_le = F2(function(a, b) { return _Utils_cmp(a, b) < 1; });
var _Utils_gt = F2(function(a, b) { return _Utils_cmp(a, b) > 0; });
var _Utils_ge = F2(function(a, b) { return _Utils_cmp(a, b) >= 0; });

var _Utils_compare = F2(function(x, y)
{
	var n = _Utils_cmp(x, y);
	return n < 0 ? elm$core$Basics$LT : n ? elm$core$Basics$GT : elm$core$Basics$EQ;
});


// COMMON VALUES

var _Utils_Tuple0 = 0;
var _Utils_Tuple0_UNUSED = { $: '#0' };

function _Utils_Tuple2(a, b) { return { a: a, b: b }; }
function _Utils_Tuple2_UNUSED(a, b) { return { $: '#2', a: a, b: b }; }

function _Utils_Tuple3(a, b, c) { return { a: a, b: b, c: c }; }
function _Utils_Tuple3_UNUSED(a, b, c) { return { $: '#3', a: a, b: b, c: c }; }

function _Utils_chr(c) { return c; }
function _Utils_chr_UNUSED(c) { return new String(c); }


// RECORDS

function _Utils_update(oldRecord, updatedFields)
{
	var newRecord = {};

	for (var key in oldRecord)
	{
		newRecord[key] = oldRecord[key];
	}

	for (var key in updatedFields)
	{
		newRecord[key] = updatedFields[key];
	}

	return newRecord;
}


// APPEND

var _Utils_append = F2(_Utils_ap);

function _Utils_ap(xs, ys)
{
	// append Strings
	if (typeof xs === 'string')
	{
		return xs + ys;
	}

	// append Lists
	if (!xs.b)
	{
		return ys;
	}
	var root = _List_Cons(xs.a, ys);
	xs = xs.b
	for (var curr = root; xs.b; xs = xs.b) // WHILE_CONS
	{
		curr = curr.b = _List_Cons(xs.a, ys);
	}
	return root;
}



var _JsArray_empty = [];

function _JsArray_singleton(value)
{
    return [value];
}

function _JsArray_length(array)
{
    return array.length;
}

var _JsArray_initialize = F3(function(size, offset, func)
{
    var result = new Array(size);

    for (var i = 0; i < size; i++)
    {
        result[i] = func(offset + i);
    }

    return result;
});

var _JsArray_initializeFromList = F2(function (max, ls)
{
    var result = new Array(max);

    for (var i = 0; i < max && ls.b; i++)
    {
        result[i] = ls.a;
        ls = ls.b;
    }

    result.length = i;
    return _Utils_Tuple2(result, ls);
});

var _JsArray_unsafeGet = F2(function(index, array)
{
    return array[index];
});

var _JsArray_unsafeSet = F3(function(index, value, array)
{
    var length = array.length;
    var result = new Array(length);

    for (var i = 0; i < length; i++)
    {
        result[i] = array[i];
    }

    result[index] = value;
    return result;
});

var _JsArray_push = F2(function(value, array)
{
    var length = array.length;
    var result = new Array(length + 1);

    for (var i = 0; i < length; i++)
    {
        result[i] = array[i];
    }

    result[length] = value;
    return result;
});

var _JsArray_foldl = F3(function(func, acc, array)
{
    var length = array.length;

    for (var i = 0; i < length; i++)
    {
        acc = A2(func, array[i], acc);
    }

    return acc;
});

var _JsArray_foldr = F3(function(func, acc, array)
{
    for (var i = array.length - 1; i >= 0; i--)
    {
        acc = A2(func, array[i], acc);
    }

    return acc;
});

var _JsArray_map = F2(function(func, array)
{
    var length = array.length;
    var result = new Array(length);

    for (var i = 0; i < length; i++)
    {
        result[i] = func(array[i]);
    }

    return result;
});

var _JsArray_indexedMap = F3(function(func, offset, array)
{
    var length = array.length;
    var result = new Array(length);

    for (var i = 0; i < length; i++)
    {
        result[i] = A2(func, offset + i, array[i]);
    }

    return result;
});

var _JsArray_slice = F3(function(from, to, array)
{
    return array.slice(from, to);
});

var _JsArray_appendN = F3(function(n, dest, source)
{
    var destLen = dest.length;
    var itemsToCopy = n - destLen;

    if (itemsToCopy > source.length)
    {
        itemsToCopy = source.length;
    }

    var size = destLen + itemsToCopy;
    var result = new Array(size);

    for (var i = 0; i < destLen; i++)
    {
        result[i] = dest[i];
    }

    for (var i = 0; i < itemsToCopy; i++)
    {
        result[i + destLen] = source[i];
    }

    return result;
});



// LOG

var _Debug_log = F2(function(tag, value)
{
	return value;
});

var _Debug_log_UNUSED = F2(function(tag, value)
{
	console.log(tag + ': ' + _Debug_toString(value));
	return value;
});


// TODOS

function _Debug_todo(moduleName, region)
{
	return function(message) {
		_Debug_crash(8, moduleName, region, message);
	};
}

function _Debug_todoCase(moduleName, region, value)
{
	return function(message) {
		_Debug_crash(9, moduleName, region, value, message);
	};
}


// TO STRING

function _Debug_toString(value)
{
	return '<internals>';
}

function _Debug_toString_UNUSED(value)
{
	return _Debug_toAnsiString(false, value);
}

function _Debug_toAnsiString(ansi, value)
{
	if (typeof value === 'function')
	{
		return _Debug_internalColor(ansi, '<function>');
	}

	if (typeof value === 'boolean')
	{
		return _Debug_ctorColor(ansi, value ? 'True' : 'False');
	}

	if (typeof value === 'number')
	{
		return _Debug_numberColor(ansi, value + '');
	}

	if (value instanceof String)
	{
		return _Debug_charColor(ansi, "'" + _Debug_addSlashes(value, true) + "'");
	}

	if (typeof value === 'string')
	{
		return _Debug_stringColor(ansi, '"' + _Debug_addSlashes(value, false) + '"');
	}

	if (typeof value === 'object' && '$' in value)
	{
		var tag = value.$;

		if (typeof tag === 'number')
		{
			return _Debug_internalColor(ansi, '<internals>');
		}

		if (tag[0] === '#')
		{
			var output = [];
			for (var k in value)
			{
				if (k === '$') continue;
				output.push(_Debug_toAnsiString(ansi, value[k]));
			}
			return '(' + output.join(',') + ')';
		}

		if (tag === 'Set_elm_builtin')
		{
			return _Debug_ctorColor(ansi, 'Set')
				+ _Debug_fadeColor(ansi, '.fromList') + ' '
				+ _Debug_toAnsiString(ansi, elm$core$Set$toList(value));
		}

		if (tag === 'RBNode_elm_builtin' || tag === 'RBEmpty_elm_builtin')
		{
			return _Debug_ctorColor(ansi, 'Dict')
				+ _Debug_fadeColor(ansi, '.fromList') + ' '
				+ _Debug_toAnsiString(ansi, elm$core$Dict$toList(value));
		}

		if (tag === 'Array_elm_builtin')
		{
			return _Debug_ctorColor(ansi, 'Array')
				+ _Debug_fadeColor(ansi, '.fromList') + ' '
				+ _Debug_toAnsiString(ansi, elm$core$Array$toList(value));
		}

		if (tag === '::' || tag === '[]')
		{
			var output = '[';

			value.b && (output += _Debug_toAnsiString(ansi, value.a), value = value.b)

			for (; value.b; value = value.b) // WHILE_CONS
			{
				output += ',' + _Debug_toAnsiString(ansi, value.a);
			}
			return output + ']';
		}

		var output = '';
		for (var i in value)
		{
			if (i === '$') continue;
			var str = _Debug_toAnsiString(ansi, value[i]);
			var c0 = str[0];
			var parenless = c0 === '{' || c0 === '(' || c0 === '[' || c0 === '<' || c0 === '"' || str.indexOf(' ') < 0;
			output += ' ' + (parenless ? str : '(' + str + ')');
		}
		return _Debug_ctorColor(ansi, tag) + output;
	}

	if (typeof DataView === 'function' && value instanceof DataView)
	{
		return _Debug_stringColor(ansi, '<' + value.byteLength + ' bytes>');
	}

	if (typeof File === 'function' && value instanceof File)
	{
		return _Debug_internalColor(ansi, '<' + value.name + '>');
	}

	if (typeof value === 'object')
	{
		var output = [];
		for (var key in value)
		{
			var field = key[0] === '_' ? key.slice(1) : key;
			output.push(_Debug_fadeColor(ansi, field) + ' = ' + _Debug_toAnsiString(ansi, value[key]));
		}
		if (output.length === 0)
		{
			return '{}';
		}
		return '{ ' + output.join(', ') + ' }';
	}

	return _Debug_internalColor(ansi, '<internals>');
}

function _Debug_addSlashes(str, isChar)
{
	var s = str
		.replace(/\\/g, '\\\\')
		.replace(/\n/g, '\\n')
		.replace(/\t/g, '\\t')
		.replace(/\r/g, '\\r')
		.replace(/\v/g, '\\v')
		.replace(/\0/g, '\\0');

	if (isChar)
	{
		return s.replace(/\'/g, '\\\'');
	}
	else
	{
		return s.replace(/\"/g, '\\"');
	}
}

function _Debug_ctorColor(ansi, string)
{
	return ansi ? '\x1b[96m' + string + '\x1b[0m' : string;
}

function _Debug_numberColor(ansi, string)
{
	return ansi ? '\x1b[95m' + string + '\x1b[0m' : string;
}

function _Debug_stringColor(ansi, string)
{
	return ansi ? '\x1b[93m' + string + '\x1b[0m' : string;
}

function _Debug_charColor(ansi, string)
{
	return ansi ? '\x1b[92m' + string + '\x1b[0m' : string;
}

function _Debug_fadeColor(ansi, string)
{
	return ansi ? '\x1b[37m' + string + '\x1b[0m' : string;
}

function _Debug_internalColor(ansi, string)
{
	return ansi ? '\x1b[94m' + string + '\x1b[0m' : string;
}

function _Debug_toHexDigit(n)
{
	return String.fromCharCode(n < 10 ? 48 + n : 55 + n);
}


// CRASH


function _Debug_crash(identifier)
{
	throw new Error('https://github.com/elm/core/blob/1.0.0/hints/' + identifier + '.md');
}


function _Debug_crash_UNUSED(identifier, fact1, fact2, fact3, fact4)
{
	switch(identifier)
	{
		case 0:
			throw new Error('What node should I take over? In JavaScript I need something like:\n\n    Elm.Main.init({\n        node: document.getElementById("elm-node")\n    })\n\nYou need to do this with any Browser.sandbox or Browser.element program.');

		case 1:
			throw new Error('Browser.application programs cannot handle URLs like this:\n\n    ' + document.location.href + '\n\nWhat is the root? The root of your file system? Try looking at this program with `elm reactor` or some other server.');

		case 2:
			var jsonErrorString = fact1;
			throw new Error('Problem with the flags given to your Elm program on initialization.\n\n' + jsonErrorString);

		case 3:
			var portName = fact1;
			throw new Error('There can only be one port named `' + portName + '`, but your program has multiple.');

		case 4:
			var portName = fact1;
			var problem = fact2;
			throw new Error('Trying to send an unexpected type of value through port `' + portName + '`:\n' + problem);

		case 5:
			throw new Error('Trying to use `(==)` on functions.\nThere is no way to know if functions are "the same" in the Elm sense.\nRead more about this at https://package.elm-lang.org/packages/elm/core/latest/Basics#== which describes why it is this way and what the better version will look like.');

		case 6:
			var moduleName = fact1;
			throw new Error('Your page is loading multiple Elm scripts with a module named ' + moduleName + '. Maybe a duplicate script is getting loaded accidentally? If not, rename one of them so I know which is which!');

		case 8:
			var moduleName = fact1;
			var region = fact2;
			var message = fact3;
			throw new Error('TODO in module `' + moduleName + '` ' + _Debug_regionToString(region) + '\n\n' + message);

		case 9:
			var moduleName = fact1;
			var region = fact2;
			var value = fact3;
			var message = fact4;
			throw new Error(
				'TODO in module `' + moduleName + '` from the `case` expression '
				+ _Debug_regionToString(region) + '\n\nIt received the following value:\n\n    '
				+ _Debug_toString(value).replace('\n', '\n    ')
				+ '\n\nBut the branch that handles it says:\n\n    ' + message.replace('\n', '\n    ')
			);

		case 10:
			throw new Error('Bug in https://github.com/elm/virtual-dom/issues');

		case 11:
			throw new Error('Cannot perform mod 0. Division by zero error.');
	}
}

function _Debug_regionToString(region)
{
	if (region.ak.L === region.ay.L)
	{
		return 'on line ' + region.ak.L;
	}
	return 'on lines ' + region.ak.L + ' through ' + region.ay.L;
}



// MATH

var _Basics_add = F2(function(a, b) { return a + b; });
var _Basics_sub = F2(function(a, b) { return a - b; });
var _Basics_mul = F2(function(a, b) { return a * b; });
var _Basics_fdiv = F2(function(a, b) { return a / b; });
var _Basics_idiv = F2(function(a, b) { return (a / b) | 0; });
var _Basics_pow = F2(Math.pow);

var _Basics_remainderBy = F2(function(b, a) { return a % b; });

// https://www.microsoft.com/en-us/research/wp-content/uploads/2016/02/divmodnote-letter.pdf
var _Basics_modBy = F2(function(modulus, x)
{
	var answer = x % modulus;
	return modulus === 0
		? _Debug_crash(11)
		:
	((answer > 0 && modulus < 0) || (answer < 0 && modulus > 0))
		? answer + modulus
		: answer;
});


// TRIGONOMETRY

var _Basics_pi = Math.PI;
var _Basics_e = Math.E;
var _Basics_cos = Math.cos;
var _Basics_sin = Math.sin;
var _Basics_tan = Math.tan;
var _Basics_acos = Math.acos;
var _Basics_asin = Math.asin;
var _Basics_atan = Math.atan;
var _Basics_atan2 = F2(Math.atan2);


// MORE MATH

function _Basics_toFloat(x) { return x; }
function _Basics_truncate(n) { return n | 0; }
function _Basics_isInfinite(n) { return n === Infinity || n === -Infinity; }

var _Basics_ceiling = Math.ceil;
var _Basics_floor = Math.floor;
var _Basics_round = Math.round;
var _Basics_sqrt = Math.sqrt;
var _Basics_log = Math.log;
var _Basics_isNaN = isNaN;


// BOOLEANS

function _Basics_not(bool) { return !bool; }
var _Basics_and = F2(function(a, b) { return a && b; });
var _Basics_or  = F2(function(a, b) { return a || b; });
var _Basics_xor = F2(function(a, b) { return a !== b; });



function _Char_toCode(char)
{
	var code = char.charCodeAt(0);
	if (0xD800 <= code && code <= 0xDBFF)
	{
		return (code - 0xD800) * 0x400 + char.charCodeAt(1) - 0xDC00 + 0x10000
	}
	return code;
}

function _Char_fromCode(code)
{
	return _Utils_chr(
		(code < 0 || 0x10FFFF < code)
			? '\uFFFD'
			:
		(code <= 0xFFFF)
			? String.fromCharCode(code)
			:
		(code -= 0x10000,
			String.fromCharCode(Math.floor(code / 0x400) + 0xD800, code % 0x400 + 0xDC00)
		)
	);
}

function _Char_toUpper(char)
{
	return _Utils_chr(char.toUpperCase());
}

function _Char_toLower(char)
{
	return _Utils_chr(char.toLowerCase());
}

function _Char_toLocaleUpper(char)
{
	return _Utils_chr(char.toLocaleUpperCase());
}

function _Char_toLocaleLower(char)
{
	return _Utils_chr(char.toLocaleLowerCase());
}



var _String_cons = F2(function(chr, str)
{
	return chr + str;
});

function _String_uncons(string)
{
	var word = string.charCodeAt(0);
	return word
		? elm$core$Maybe$Just(
			0xD800 <= word && word <= 0xDBFF
				? _Utils_Tuple2(_Utils_chr(string[0] + string[1]), string.slice(2))
				: _Utils_Tuple2(_Utils_chr(string[0]), string.slice(1))
		)
		: elm$core$Maybe$Nothing;
}

var _String_append = F2(function(a, b)
{
	return a + b;
});

function _String_length(str)
{
	return str.length;
}

var _String_map = F2(function(func, string)
{
	var len = string.length;
	var array = new Array(len);
	var i = 0;
	while (i < len)
	{
		var word = string.charCodeAt(i);
		if (0xD800 <= word && word <= 0xDBFF)
		{
			array[i] = func(_Utils_chr(string[i] + string[i+1]));
			i += 2;
			continue;
		}
		array[i] = func(_Utils_chr(string[i]));
		i++;
	}
	return array.join('');
});

var _String_filter = F2(function(isGood, str)
{
	var arr = [];
	var len = str.length;
	var i = 0;
	while (i < len)
	{
		var char = str[i];
		var word = str.charCodeAt(i);
		i++;
		if (0xD800 <= word && word <= 0xDBFF)
		{
			char += str[i];
			i++;
		}

		if (isGood(_Utils_chr(char)))
		{
			arr.push(char);
		}
	}
	return arr.join('');
});

function _String_reverse(str)
{
	var len = str.length;
	var arr = new Array(len);
	var i = 0;
	while (i < len)
	{
		var word = str.charCodeAt(i);
		if (0xD800 <= word && word <= 0xDBFF)
		{
			arr[len - i] = str[i + 1];
			i++;
			arr[len - i] = str[i - 1];
			i++;
		}
		else
		{
			arr[len - i] = str[i];
			i++;
		}
	}
	return arr.join('');
}

var _String_foldl = F3(function(func, state, string)
{
	var len = string.length;
	var i = 0;
	while (i < len)
	{
		var char = string[i];
		var word = string.charCodeAt(i);
		i++;
		if (0xD800 <= word && word <= 0xDBFF)
		{
			char += string[i];
			i++;
		}
		state = A2(func, _Utils_chr(char), state);
	}
	return state;
});

var _String_foldr = F3(function(func, state, string)
{
	var i = string.length;
	while (i--)
	{
		var char = string[i];
		var word = string.charCodeAt(i);
		if (0xDC00 <= word && word <= 0xDFFF)
		{
			i--;
			char = string[i] + char;
		}
		state = A2(func, _Utils_chr(char), state);
	}
	return state;
});

var _String_split = F2(function(sep, str)
{
	return str.split(sep);
});

var _String_join = F2(function(sep, strs)
{
	return strs.join(sep);
});

var _String_slice = F3(function(start, end, str) {
	return str.slice(start, end);
});

function _String_trim(str)
{
	return str.trim();
}

function _String_trimLeft(str)
{
	return str.replace(/^\s+/, '');
}

function _String_trimRight(str)
{
	return str.replace(/\s+$/, '');
}

function _String_words(str)
{
	return _List_fromArray(str.trim().split(/\s+/g));
}

function _String_lines(str)
{
	return _List_fromArray(str.split(/\r\n|\r|\n/g));
}

function _String_toUpper(str)
{
	return str.toUpperCase();
}

function _String_toLower(str)
{
	return str.toLowerCase();
}

var _String_any = F2(function(isGood, string)
{
	var i = string.length;
	while (i--)
	{
		var char = string[i];
		var word = string.charCodeAt(i);
		if (0xDC00 <= word && word <= 0xDFFF)
		{
			i--;
			char = string[i] + char;
		}
		if (isGood(_Utils_chr(char)))
		{
			return true;
		}
	}
	return false;
});

var _String_all = F2(function(isGood, string)
{
	var i = string.length;
	while (i--)
	{
		var char = string[i];
		var word = string.charCodeAt(i);
		if (0xDC00 <= word && word <= 0xDFFF)
		{
			i--;
			char = string[i] + char;
		}
		if (!isGood(_Utils_chr(char)))
		{
			return false;
		}
	}
	return true;
});

var _String_contains = F2(function(sub, str)
{
	return str.indexOf(sub) > -1;
});

var _String_startsWith = F2(function(sub, str)
{
	return str.indexOf(sub) === 0;
});

var _String_endsWith = F2(function(sub, str)
{
	return str.length >= sub.length &&
		str.lastIndexOf(sub) === str.length - sub.length;
});

var _String_indexes = F2(function(sub, str)
{
	var subLen = sub.length;

	if (subLen < 1)
	{
		return _List_Nil;
	}

	var i = 0;
	var is = [];

	while ((i = str.indexOf(sub, i)) > -1)
	{
		is.push(i);
		i = i + subLen;
	}

	return _List_fromArray(is);
});


// TO STRING

function _String_fromNumber(number)
{
	return number + '';
}


// INT CONVERSIONS

function _String_toInt(str)
{
	var total = 0;
	var code0 = str.charCodeAt(0);
	var start = code0 == 0x2B /* + */ || code0 == 0x2D /* - */ ? 1 : 0;

	for (var i = start; i < str.length; ++i)
	{
		var code = str.charCodeAt(i);
		if (code < 0x30 || 0x39 < code)
		{
			return elm$core$Maybe$Nothing;
		}
		total = 10 * total + code - 0x30;
	}

	return i == start
		? elm$core$Maybe$Nothing
		: elm$core$Maybe$Just(code0 == 0x2D ? -total : total);
}


// FLOAT CONVERSIONS

function _String_toFloat(s)
{
	// check if it is a hex, octal, or binary number
	if (s.length === 0 || /[\sxbo]/.test(s))
	{
		return elm$core$Maybe$Nothing;
	}
	var n = +s;
	// faster isNaN check
	return n === n ? elm$core$Maybe$Just(n) : elm$core$Maybe$Nothing;
}

function _String_fromList(chars)
{
	return _List_toArray(chars).join('');
}




/**_UNUSED/
function _Json_errorToString(error)
{
	return elm$json$Json$Decode$errorToString(error);
}
//*/


// CORE DECODERS

function _Json_succeed(msg)
{
	return {
		$: 0,
		a: msg
	};
}

function _Json_fail(msg)
{
	return {
		$: 1,
		a: msg
	};
}

function _Json_decodePrim(decoder)
{
	return { $: 2, b: decoder };
}

var _Json_decodeInt = _Json_decodePrim(function(value) {
	return (typeof value !== 'number')
		? _Json_expecting('an INT', value)
		:
	(-2147483647 < value && value < 2147483647 && (value | 0) === value)
		? elm$core$Result$Ok(value)
		:
	(isFinite(value) && !(value % 1))
		? elm$core$Result$Ok(value)
		: _Json_expecting('an INT', value);
});

var _Json_decodeBool = _Json_decodePrim(function(value) {
	return (typeof value === 'boolean')
		? elm$core$Result$Ok(value)
		: _Json_expecting('a BOOL', value);
});

var _Json_decodeFloat = _Json_decodePrim(function(value) {
	return (typeof value === 'number')
		? elm$core$Result$Ok(value)
		: _Json_expecting('a FLOAT', value);
});

var _Json_decodeValue = _Json_decodePrim(function(value) {
	return elm$core$Result$Ok(_Json_wrap(value));
});

var _Json_decodeString = _Json_decodePrim(function(value) {
	return (typeof value === 'string')
		? elm$core$Result$Ok(value)
		: (value instanceof String)
			? elm$core$Result$Ok(value + '')
			: _Json_expecting('a STRING', value);
});

function _Json_decodeList(decoder) { return { $: 3, b: decoder }; }
function _Json_decodeArray(decoder) { return { $: 4, b: decoder }; }

function _Json_decodeNull(value) { return { $: 5, c: value }; }

var _Json_decodeField = F2(function(field, decoder)
{
	return {
		$: 6,
		d: field,
		b: decoder
	};
});

var _Json_decodeIndex = F2(function(index, decoder)
{
	return {
		$: 7,
		e: index,
		b: decoder
	};
});

function _Json_decodeKeyValuePairs(decoder)
{
	return {
		$: 8,
		b: decoder
	};
}

function _Json_mapMany(f, decoders)
{
	return {
		$: 9,
		f: f,
		g: decoders
	};
}

var _Json_andThen = F2(function(callback, decoder)
{
	return {
		$: 10,
		b: decoder,
		h: callback
	};
});

function _Json_oneOf(decoders)
{
	return {
		$: 11,
		g: decoders
	};
}


// DECODING OBJECTS

var _Json_map1 = F2(function(f, d1)
{
	return _Json_mapMany(f, [d1]);
});

var _Json_map2 = F3(function(f, d1, d2)
{
	return _Json_mapMany(f, [d1, d2]);
});

var _Json_map3 = F4(function(f, d1, d2, d3)
{
	return _Json_mapMany(f, [d1, d2, d3]);
});

var _Json_map4 = F5(function(f, d1, d2, d3, d4)
{
	return _Json_mapMany(f, [d1, d2, d3, d4]);
});

var _Json_map5 = F6(function(f, d1, d2, d3, d4, d5)
{
	return _Json_mapMany(f, [d1, d2, d3, d4, d5]);
});

var _Json_map6 = F7(function(f, d1, d2, d3, d4, d5, d6)
{
	return _Json_mapMany(f, [d1, d2, d3, d4, d5, d6]);
});

var _Json_map7 = F8(function(f, d1, d2, d3, d4, d5, d6, d7)
{
	return _Json_mapMany(f, [d1, d2, d3, d4, d5, d6, d7]);
});

var _Json_map8 = F9(function(f, d1, d2, d3, d4, d5, d6, d7, d8)
{
	return _Json_mapMany(f, [d1, d2, d3, d4, d5, d6, d7, d8]);
});


// DECODE

var _Json_runOnString = F2(function(decoder, string)
{
	try
	{
		var value = JSON.parse(string);
		return _Json_runHelp(decoder, value);
	}
	catch (e)
	{
		return elm$core$Result$Err(A2(elm$json$Json$Decode$Failure, 'This is not valid JSON! ' + e.message, _Json_wrap(string)));
	}
});

var _Json_run = F2(function(decoder, value)
{
	return _Json_runHelp(decoder, _Json_unwrap(value));
});

function _Json_runHelp(decoder, value)
{
	switch (decoder.$)
	{
		case 2:
			return decoder.b(value);

		case 5:
			return (value === null)
				? elm$core$Result$Ok(decoder.c)
				: _Json_expecting('null', value);

		case 3:
			if (!_Json_isArray(value))
			{
				return _Json_expecting('a LIST', value);
			}
			return _Json_runArrayDecoder(decoder.b, value, _List_fromArray);

		case 4:
			if (!_Json_isArray(value))
			{
				return _Json_expecting('an ARRAY', value);
			}
			return _Json_runArrayDecoder(decoder.b, value, _Json_toElmArray);

		case 6:
			var field = decoder.d;
			if (typeof value !== 'object' || value === null || !(field in value))
			{
				return _Json_expecting('an OBJECT with a field named `' + field + '`', value);
			}
			var result = _Json_runHelp(decoder.b, value[field]);
			return (elm$core$Result$isOk(result)) ? result : elm$core$Result$Err(A2(elm$json$Json$Decode$Field, field, result.a));

		case 7:
			var index = decoder.e;
			if (!_Json_isArray(value))
			{
				return _Json_expecting('an ARRAY', value);
			}
			if (index >= value.length)
			{
				return _Json_expecting('a LONGER array. Need index ' + index + ' but only see ' + value.length + ' entries', value);
			}
			var result = _Json_runHelp(decoder.b, value[index]);
			return (elm$core$Result$isOk(result)) ? result : elm$core$Result$Err(A2(elm$json$Json$Decode$Index, index, result.a));

		case 8:
			if (typeof value !== 'object' || value === null || _Json_isArray(value))
			{
				return _Json_expecting('an OBJECT', value);
			}

			var keyValuePairs = _List_Nil;
			// TODO test perf of Object.keys and switch when support is good enough
			for (var key in value)
			{
				if (value.hasOwnProperty(key))
				{
					var result = _Json_runHelp(decoder.b, value[key]);
					if (!elm$core$Result$isOk(result))
					{
						return elm$core$Result$Err(A2(elm$json$Json$Decode$Field, key, result.a));
					}
					keyValuePairs = _List_Cons(_Utils_Tuple2(key, result.a), keyValuePairs);
				}
			}
			return elm$core$Result$Ok(elm$core$List$reverse(keyValuePairs));

		case 9:
			var answer = decoder.f;
			var decoders = decoder.g;
			for (var i = 0; i < decoders.length; i++)
			{
				var result = _Json_runHelp(decoders[i], value);
				if (!elm$core$Result$isOk(result))
				{
					return result;
				}
				answer = answer(result.a);
			}
			return elm$core$Result$Ok(answer);

		case 10:
			var result = _Json_runHelp(decoder.b, value);
			return (!elm$core$Result$isOk(result))
				? result
				: _Json_runHelp(decoder.h(result.a), value);

		case 11:
			var errors = _List_Nil;
			for (var temp = decoder.g; temp.b; temp = temp.b) // WHILE_CONS
			{
				var result = _Json_runHelp(temp.a, value);
				if (elm$core$Result$isOk(result))
				{
					return result;
				}
				errors = _List_Cons(result.a, errors);
			}
			return elm$core$Result$Err(elm$json$Json$Decode$OneOf(elm$core$List$reverse(errors)));

		case 1:
			return elm$core$Result$Err(A2(elm$json$Json$Decode$Failure, decoder.a, _Json_wrap(value)));

		case 0:
			return elm$core$Result$Ok(decoder.a);
	}
}

function _Json_runArrayDecoder(decoder, value, toElmValue)
{
	var len = value.length;
	var array = new Array(len);
	for (var i = 0; i < len; i++)
	{
		var result = _Json_runHelp(decoder, value[i]);
		if (!elm$core$Result$isOk(result))
		{
			return elm$core$Result$Err(A2(elm$json$Json$Decode$Index, i, result.a));
		}
		array[i] = result.a;
	}
	return elm$core$Result$Ok(toElmValue(array));
}

function _Json_isArray(value)
{
	return Array.isArray(value) || (typeof FileList !== 'undefined' && value instanceof FileList);
}

function _Json_toElmArray(array)
{
	return A2(elm$core$Array$initialize, array.length, function(i) { return array[i]; });
}

function _Json_expecting(type, value)
{
	return elm$core$Result$Err(A2(elm$json$Json$Decode$Failure, 'Expecting ' + type, _Json_wrap(value)));
}


// EQUALITY

function _Json_equality(x, y)
{
	if (x === y)
	{
		return true;
	}

	if (x.$ !== y.$)
	{
		return false;
	}

	switch (x.$)
	{
		case 0:
		case 1:
			return x.a === y.a;

		case 2:
			return x.b === y.b;

		case 5:
			return x.c === y.c;

		case 3:
		case 4:
		case 8:
			return _Json_equality(x.b, y.b);

		case 6:
			return x.d === y.d && _Json_equality(x.b, y.b);

		case 7:
			return x.e === y.e && _Json_equality(x.b, y.b);

		case 9:
			return x.f === y.f && _Json_listEquality(x.g, y.g);

		case 10:
			return x.h === y.h && _Json_equality(x.b, y.b);

		case 11:
			return _Json_listEquality(x.g, y.g);
	}
}

function _Json_listEquality(aDecoders, bDecoders)
{
	var len = aDecoders.length;
	if (len !== bDecoders.length)
	{
		return false;
	}
	for (var i = 0; i < len; i++)
	{
		if (!_Json_equality(aDecoders[i], bDecoders[i]))
		{
			return false;
		}
	}
	return true;
}


// ENCODE

var _Json_encode = F2(function(indentLevel, value)
{
	return JSON.stringify(_Json_unwrap(value), null, indentLevel) + '';
});

function _Json_wrap_UNUSED(value) { return { $: 0, a: value }; }
function _Json_unwrap_UNUSED(value) { return value.a; }

function _Json_wrap(value) { return value; }
function _Json_unwrap(value) { return value; }

function _Json_emptyArray() { return []; }
function _Json_emptyObject() { return {}; }

var _Json_addField = F3(function(key, value, object)
{
	object[key] = _Json_unwrap(value);
	return object;
});

function _Json_addEntry(func)
{
	return F2(function(entry, array)
	{
		array.push(_Json_unwrap(func(entry)));
		return array;
	});
}

var _Json_encodeNull = _Json_wrap(null);



var _Bitwise_and = F2(function(a, b)
{
	return a & b;
});

var _Bitwise_or = F2(function(a, b)
{
	return a | b;
});

var _Bitwise_xor = F2(function(a, b)
{
	return a ^ b;
});

function _Bitwise_complement(a)
{
	return ~a;
};

var _Bitwise_shiftLeftBy = F2(function(offset, a)
{
	return a << offset;
});

var _Bitwise_shiftRightBy = F2(function(offset, a)
{
	return a >> offset;
});

var _Bitwise_shiftRightZfBy = F2(function(offset, a)
{
	return a >>> offset;
});


// CREATE

var _Regex_never = /.^/;

var _Regex_fromStringWith = F2(function(options, string)
{
	var flags = 'g';
	if (options.aP) { flags += 'm'; }
	if (options.at) { flags += 'i'; }

	try
	{
		return elm$core$Maybe$Just(new RegExp(string, flags));
	}
	catch(error)
	{
		return elm$core$Maybe$Nothing;
	}
});


// USE

var _Regex_contains = F2(function(re, string)
{
	return string.match(re) !== null;
});


var _Regex_findAtMost = F3(function(n, re, str)
{
	var out = [];
	var number = 0;
	var string = str;
	var lastIndex = re.lastIndex;
	var prevLastIndex = -1;
	var result;
	while (number++ < n && (result = re.exec(string)))
	{
		if (prevLastIndex == re.lastIndex) break;
		var i = result.length - 1;
		var subs = new Array(i);
		while (i > 0)
		{
			var submatch = result[i];
			subs[--i] = submatch
				? elm$core$Maybe$Just(submatch)
				: elm$core$Maybe$Nothing;
		}
		out.push(A4(elm$regex$Regex$Match, result[0], result.index, number, _List_fromArray(subs)));
		prevLastIndex = re.lastIndex;
	}
	re.lastIndex = lastIndex;
	return _List_fromArray(out);
});


var _Regex_replaceAtMost = F4(function(n, re, replacer, string)
{
	var count = 0;
	function jsReplacer(match)
	{
		if (count++ >= n)
		{
			return match;
		}
		var i = arguments.length - 3;
		var submatches = new Array(i);
		while (i > 0)
		{
			var submatch = arguments[i];
			submatches[--i] = submatch
				? elm$core$Maybe$Just(submatch)
				: elm$core$Maybe$Nothing;
		}
		return replacer(A4(elm$regex$Regex$Match, match, arguments[arguments.length - 2], count, _List_fromArray(submatches)));
	}
	return string.replace(re, jsReplacer);
});

var _Regex_splitAtMost = F3(function(n, re, str)
{
	var string = str;
	var out = [];
	var start = re.lastIndex;
	var restoreLastIndex = re.lastIndex;
	while (n--)
	{
		var result = re.exec(string);
		if (!result) break;
		out.push(string.slice(start, result.index));
		start = re.lastIndex;
	}
	out.push(string.slice(start));
	re.lastIndex = restoreLastIndex;
	return _List_fromArray(out);
});

var _Regex_infinity = Infinity;



// TASKS

function _Scheduler_succeed(value)
{
	return {
		$: 0,
		a: value
	};
}

function _Scheduler_fail(error)
{
	return {
		$: 1,
		a: error
	};
}

function _Scheduler_binding(callback)
{
	return {
		$: 2,
		b: callback,
		c: null
	};
}

var _Scheduler_andThen = F2(function(callback, task)
{
	return {
		$: 3,
		b: callback,
		d: task
	};
});

var _Scheduler_onError = F2(function(callback, task)
{
	return {
		$: 4,
		b: callback,
		d: task
	};
});

function _Scheduler_receive(callback)
{
	return {
		$: 5,
		b: callback
	};
}


// PROCESSES

var _Scheduler_guid = 0;

function _Scheduler_rawSpawn(task)
{
	var proc = {
		$: 0,
		e: _Scheduler_guid++,
		f: task,
		g: null,
		h: []
	};

	_Scheduler_enqueue(proc);

	return proc;
}

function _Scheduler_spawn(task)
{
	return _Scheduler_binding(function(callback) {
		callback(_Scheduler_succeed(_Scheduler_rawSpawn(task)));
	});
}

function _Scheduler_rawSend(proc, msg)
{
	proc.h.push(msg);
	_Scheduler_enqueue(proc);
}

var _Scheduler_send = F2(function(proc, msg)
{
	return _Scheduler_binding(function(callback) {
		_Scheduler_rawSend(proc, msg);
		callback(_Scheduler_succeed(_Utils_Tuple0));
	});
});

function _Scheduler_kill(proc)
{
	return _Scheduler_binding(function(callback) {
		var task = proc.f;
		if (task.$ === 2 && task.c)
		{
			task.c();
		}

		proc.f = null;

		callback(_Scheduler_succeed(_Utils_Tuple0));
	});
}


/* STEP PROCESSES

type alias Process =
  { $ : tag
  , id : unique_id
  , root : Task
  , stack : null | { $: SUCCEED | FAIL, a: callback, b: stack }
  , mailbox : [msg]
  }

*/


var _Scheduler_working = false;
var _Scheduler_queue = [];


function _Scheduler_enqueue(proc)
{
	_Scheduler_queue.push(proc);
	if (_Scheduler_working)
	{
		return;
	}
	_Scheduler_working = true;
	while (proc = _Scheduler_queue.shift())
	{
		_Scheduler_step(proc);
	}
	_Scheduler_working = false;
}


function _Scheduler_step(proc)
{
	while (proc.f)
	{
		var rootTag = proc.f.$;
		if (rootTag === 0 || rootTag === 1)
		{
			while (proc.g && proc.g.$ !== rootTag)
			{
				proc.g = proc.g.i;
			}
			if (!proc.g)
			{
				return;
			}
			proc.f = proc.g.b(proc.f.a);
			proc.g = proc.g.i;
		}
		else if (rootTag === 2)
		{
			proc.f.c = proc.f.b(function(newRoot) {
				proc.f = newRoot;
				_Scheduler_enqueue(proc);
			});
			return;
		}
		else if (rootTag === 5)
		{
			if (proc.h.length === 0)
			{
				return;
			}
			proc.f = proc.f.b(proc.h.shift());
		}
		else // if (rootTag === 3 || rootTag === 4)
		{
			proc.g = {
				$: rootTag === 3 ? 0 : 1,
				b: proc.f.b,
				i: proc.g
			};
			proc.f = proc.f.d;
		}
	}
}



function _Process_sleep(time)
{
	return _Scheduler_binding(function(callback) {
		var id = setTimeout(function() {
			callback(_Scheduler_succeed(_Utils_Tuple0));
		}, time);

		return function() { clearTimeout(id); };
	});
}




// PROGRAMS


var _Platform_worker = F4(function(impl, flagDecoder, debugMetadata, args)
{
	return _Platform_initialize(
		flagDecoder,
		args,
		impl.bz,
		impl.bW,
		impl.bS,
		function() { return function() {} }
	);
});



// INITIALIZE A PROGRAM


function _Platform_initialize(flagDecoder, args, init, update, subscriptions, stepperBuilder)
{
	var result = A2(_Json_run, flagDecoder, _Json_wrap(args ? args['flags'] : undefined));
	elm$core$Result$isOk(result) || _Debug_crash(2 /**_UNUSED/, _Json_errorToString(result.a) /**/);
	var managers = {};
	result = init(result.a);
	var model = result.a;
	var stepper = stepperBuilder(sendToApp, model);
	var ports = _Platform_setupEffects(managers, sendToApp);

	function sendToApp(msg, viewMetadata)
	{
		result = A2(update, msg, model);
		stepper(model = result.a, viewMetadata);
		_Platform_dispatchEffects(managers, result.b, subscriptions(model));
	}

	_Platform_dispatchEffects(managers, result.b, subscriptions(model));

	return ports ? { ports: ports } : {};
}



// TRACK PRELOADS
//
// This is used by code in elm/browser and elm/http
// to register any HTTP requests that are triggered by init.
//


var _Platform_preload;


function _Platform_registerPreload(url)
{
	_Platform_preload.add(url);
}



// EFFECT MANAGERS


var _Platform_effectManagers = {};


function _Platform_setupEffects(managers, sendToApp)
{
	var ports;

	// setup all necessary effect managers
	for (var key in _Platform_effectManagers)
	{
		var manager = _Platform_effectManagers[key];

		if (manager.a)
		{
			ports = ports || {};
			ports[key] = manager.a(key, sendToApp);
		}

		managers[key] = _Platform_instantiateManager(manager, sendToApp);
	}

	return ports;
}


function _Platform_createManager(init, onEffects, onSelfMsg, cmdMap, subMap)
{
	return {
		b: init,
		c: onEffects,
		d: onSelfMsg,
		e: cmdMap,
		f: subMap
	};
}


function _Platform_instantiateManager(info, sendToApp)
{
	var router = {
		g: sendToApp,
		h: undefined
	};

	var onEffects = info.c;
	var onSelfMsg = info.d;
	var cmdMap = info.e;
	var subMap = info.f;

	function loop(state)
	{
		return A2(_Scheduler_andThen, loop, _Scheduler_receive(function(msg)
		{
			var value = msg.a;

			if (msg.$ === 0)
			{
				return A3(onSelfMsg, router, value, state);
			}

			return cmdMap && subMap
				? A4(onEffects, router, value.i, value.j, state)
				: A3(onEffects, router, cmdMap ? value.i : value.j, state);
		}));
	}

	return router.h = _Scheduler_rawSpawn(A2(_Scheduler_andThen, loop, info.b));
}



// ROUTING


var _Platform_sendToApp = F2(function(router, msg)
{
	return _Scheduler_binding(function(callback)
	{
		router.g(msg);
		callback(_Scheduler_succeed(_Utils_Tuple0));
	});
});


var _Platform_sendToSelf = F2(function(router, msg)
{
	return A2(_Scheduler_send, router.h, {
		$: 0,
		a: msg
	});
});



// BAGS


function _Platform_leaf(home)
{
	return function(value)
	{
		return {
			$: 1,
			k: home,
			l: value
		};
	};
}


function _Platform_batch(list)
{
	return {
		$: 2,
		m: list
	};
}


var _Platform_map = F2(function(tagger, bag)
{
	return {
		$: 3,
		n: tagger,
		o: bag
	}
});



// PIPE BAGS INTO EFFECT MANAGERS


function _Platform_dispatchEffects(managers, cmdBag, subBag)
{
	var effectsDict = {};
	_Platform_gatherEffects(true, cmdBag, effectsDict, null);
	_Platform_gatherEffects(false, subBag, effectsDict, null);

	for (var home in managers)
	{
		_Scheduler_rawSend(managers[home], {
			$: 'fx',
			a: effectsDict[home] || { i: _List_Nil, j: _List_Nil }
		});
	}
}


function _Platform_gatherEffects(isCmd, bag, effectsDict, taggers)
{
	switch (bag.$)
	{
		case 1:
			var home = bag.k;
			var effect = _Platform_toEffect(isCmd, home, taggers, bag.l);
			effectsDict[home] = _Platform_insert(isCmd, effect, effectsDict[home]);
			return;

		case 2:
			for (var list = bag.m; list.b; list = list.b) // WHILE_CONS
			{
				_Platform_gatherEffects(isCmd, list.a, effectsDict, taggers);
			}
			return;

		case 3:
			_Platform_gatherEffects(isCmd, bag.o, effectsDict, {
				p: bag.n,
				q: taggers
			});
			return;
	}
}


function _Platform_toEffect(isCmd, home, taggers, value)
{
	function applyTaggers(x)
	{
		for (var temp = taggers; temp; temp = temp.q)
		{
			x = temp.p(x);
		}
		return x;
	}

	var map = isCmd
		? _Platform_effectManagers[home].e
		: _Platform_effectManagers[home].f;

	return A2(map, applyTaggers, value)
}


function _Platform_insert(isCmd, newEffect, effects)
{
	effects = effects || { i: _List_Nil, j: _List_Nil };

	isCmd
		? (effects.i = _List_Cons(newEffect, effects.i))
		: (effects.j = _List_Cons(newEffect, effects.j));

	return effects;
}



// PORTS


function _Platform_checkPortName(name)
{
	if (_Platform_effectManagers[name])
	{
		_Debug_crash(3, name)
	}
}



// OUTGOING PORTS


function _Platform_outgoingPort(name, converter)
{
	_Platform_checkPortName(name);
	_Platform_effectManagers[name] = {
		e: _Platform_outgoingPortMap,
		r: converter,
		a: _Platform_setupOutgoingPort
	};
	return _Platform_leaf(name);
}


var _Platform_outgoingPortMap = F2(function(tagger, value) { return value; });


function _Platform_setupOutgoingPort(name)
{
	var subs = [];
	var converter = _Platform_effectManagers[name].r;

	// CREATE MANAGER

	var init = _Process_sleep(0);

	_Platform_effectManagers[name].b = init;
	_Platform_effectManagers[name].c = F3(function(router, cmdList, state)
	{
		for ( ; cmdList.b; cmdList = cmdList.b) // WHILE_CONS
		{
			// grab a separate reference to subs in case unsubscribe is called
			var currentSubs = subs;
			var value = _Json_unwrap(converter(cmdList.a));
			for (var i = 0; i < currentSubs.length; i++)
			{
				currentSubs[i](value);
			}
		}
		return init;
	});

	// PUBLIC API

	function subscribe(callback)
	{
		subs.push(callback);
	}

	function unsubscribe(callback)
	{
		// copy subs into a new array in case unsubscribe is called within a
		// subscribed callback
		subs = subs.slice();
		var index = subs.indexOf(callback);
		if (index >= 0)
		{
			subs.splice(index, 1);
		}
	}

	return {
		subscribe: subscribe,
		unsubscribe: unsubscribe
	};
}



// INCOMING PORTS


function _Platform_incomingPort(name, converter)
{
	_Platform_checkPortName(name);
	_Platform_effectManagers[name] = {
		f: _Platform_incomingPortMap,
		r: converter,
		a: _Platform_setupIncomingPort
	};
	return _Platform_leaf(name);
}


var _Platform_incomingPortMap = F2(function(tagger, finalTagger)
{
	return function(value)
	{
		return tagger(finalTagger(value));
	};
});


function _Platform_setupIncomingPort(name, sendToApp)
{
	var subs = _List_Nil;
	var converter = _Platform_effectManagers[name].r;

	// CREATE MANAGER

	var init = _Scheduler_succeed(null);

	_Platform_effectManagers[name].b = init;
	_Platform_effectManagers[name].c = F3(function(router, subList, state)
	{
		subs = subList;
		return init;
	});

	// PUBLIC API

	function send(incomingValue)
	{
		var result = A2(_Json_run, converter, _Json_wrap(incomingValue));

		elm$core$Result$isOk(result) || _Debug_crash(4, name, result.a);

		var value = result.a;
		for (var temp = subs; temp.b; temp = temp.b) // WHILE_CONS
		{
			sendToApp(temp.a(value));
		}
	}

	return { send: send };
}



// EXPORT ELM MODULES
//
// Have DEBUG and PROD versions so that we can (1) give nicer errors in
// debug mode and (2) not pay for the bits needed for that in prod mode.
//


function _Platform_export(exports)
{
	scope['Elm']
		? _Platform_mergeExportsProd(scope['Elm'], exports)
		: scope['Elm'] = exports;
}


function _Platform_mergeExportsProd(obj, exports)
{
	for (var name in exports)
	{
		(name in obj)
			? (name == 'init')
				? _Debug_crash(6)
				: _Platform_mergeExportsProd(obj[name], exports[name])
			: (obj[name] = exports[name]);
	}
}


function _Platform_export_UNUSED(exports)
{
	scope['Elm']
		? _Platform_mergeExportsDebug('Elm', scope['Elm'], exports)
		: scope['Elm'] = exports;
}


function _Platform_mergeExportsDebug(moduleName, obj, exports)
{
	for (var name in exports)
	{
		(name in obj)
			? (name == 'init')
				? _Debug_crash(6, moduleName)
				: _Platform_mergeExportsDebug(moduleName + '.' + name, obj[name], exports[name])
			: (obj[name] = exports[name]);
	}
}
var elm$core$Array$branchFactor = 32;
var elm$core$Array$Array_elm_builtin = F4(
	function (a, b, c, d) {
		return {$: 0, a: a, b: b, c: c, d: d};
	});
var elm$core$Basics$EQ = 1;
var elm$core$Basics$GT = 2;
var elm$core$Basics$LT = 0;
var elm$core$Dict$foldr = F3(
	function (func, acc, t) {
		foldr:
		while (true) {
			if (t.$ === -2) {
				return acc;
			} else {
				var key = t.b;
				var value = t.c;
				var left = t.d;
				var right = t.e;
				var $temp$func = func,
					$temp$acc = A3(
					func,
					key,
					value,
					A3(elm$core$Dict$foldr, func, acc, right)),
					$temp$t = left;
				func = $temp$func;
				acc = $temp$acc;
				t = $temp$t;
				continue foldr;
			}
		}
	});
var elm$core$List$cons = _List_cons;
var elm$core$Dict$toList = function (dict) {
	return A3(
		elm$core$Dict$foldr,
		F3(
			function (key, value, list) {
				return A2(
					elm$core$List$cons,
					_Utils_Tuple2(key, value),
					list);
			}),
		_List_Nil,
		dict);
};
var elm$core$Dict$keys = function (dict) {
	return A3(
		elm$core$Dict$foldr,
		F3(
			function (key, value, keyList) {
				return A2(elm$core$List$cons, key, keyList);
			}),
		_List_Nil,
		dict);
};
var elm$core$Set$toList = function (_n0) {
	var dict = _n0;
	return elm$core$Dict$keys(dict);
};
var elm$core$Elm$JsArray$foldr = _JsArray_foldr;
var elm$core$Array$foldr = F3(
	function (func, baseCase, _n0) {
		var tree = _n0.c;
		var tail = _n0.d;
		var helper = F2(
			function (node, acc) {
				if (!node.$) {
					var subTree = node.a;
					return A3(elm$core$Elm$JsArray$foldr, helper, acc, subTree);
				} else {
					var values = node.a;
					return A3(elm$core$Elm$JsArray$foldr, func, acc, values);
				}
			});
		return A3(
			elm$core$Elm$JsArray$foldr,
			helper,
			A3(elm$core$Elm$JsArray$foldr, func, baseCase, tail),
			tree);
	});
var elm$core$Array$toList = function (array) {
	return A3(elm$core$Array$foldr, elm$core$List$cons, _List_Nil, array);
};
var elm$core$Basics$ceiling = _Basics_ceiling;
var elm$core$Basics$fdiv = _Basics_fdiv;
var elm$core$Basics$logBase = F2(
	function (base, number) {
		return _Basics_log(number) / _Basics_log(base);
	});
var elm$core$Basics$toFloat = _Basics_toFloat;
var elm$core$Array$shiftStep = elm$core$Basics$ceiling(
	A2(elm$core$Basics$logBase, 2, elm$core$Array$branchFactor));
var elm$core$Elm$JsArray$empty = _JsArray_empty;
var elm$core$Array$empty = A4(elm$core$Array$Array_elm_builtin, 0, elm$core$Array$shiftStep, elm$core$Elm$JsArray$empty, elm$core$Elm$JsArray$empty);
var elm$core$Array$Leaf = function (a) {
	return {$: 1, a: a};
};
var elm$core$Array$SubTree = function (a) {
	return {$: 0, a: a};
};
var elm$core$Elm$JsArray$initializeFromList = _JsArray_initializeFromList;
var elm$core$List$foldl = F3(
	function (func, acc, list) {
		foldl:
		while (true) {
			if (!list.b) {
				return acc;
			} else {
				var x = list.a;
				var xs = list.b;
				var $temp$func = func,
					$temp$acc = A2(func, x, acc),
					$temp$list = xs;
				func = $temp$func;
				acc = $temp$acc;
				list = $temp$list;
				continue foldl;
			}
		}
	});
var elm$core$List$reverse = function (list) {
	return A3(elm$core$List$foldl, elm$core$List$cons, _List_Nil, list);
};
var elm$core$Array$compressNodes = F2(
	function (nodes, acc) {
		compressNodes:
		while (true) {
			var _n0 = A2(elm$core$Elm$JsArray$initializeFromList, elm$core$Array$branchFactor, nodes);
			var node = _n0.a;
			var remainingNodes = _n0.b;
			var newAcc = A2(
				elm$core$List$cons,
				elm$core$Array$SubTree(node),
				acc);
			if (!remainingNodes.b) {
				return elm$core$List$reverse(newAcc);
			} else {
				var $temp$nodes = remainingNodes,
					$temp$acc = newAcc;
				nodes = $temp$nodes;
				acc = $temp$acc;
				continue compressNodes;
			}
		}
	});
var elm$core$Basics$apR = F2(
	function (x, f) {
		return f(x);
	});
var elm$core$Basics$eq = _Utils_equal;
var elm$core$Tuple$first = function (_n0) {
	var x = _n0.a;
	return x;
};
var elm$core$Array$treeFromBuilder = F2(
	function (nodeList, nodeListSize) {
		treeFromBuilder:
		while (true) {
			var newNodeSize = elm$core$Basics$ceiling(nodeListSize / elm$core$Array$branchFactor);
			if (newNodeSize === 1) {
				return A2(elm$core$Elm$JsArray$initializeFromList, elm$core$Array$branchFactor, nodeList).a;
			} else {
				var $temp$nodeList = A2(elm$core$Array$compressNodes, nodeList, _List_Nil),
					$temp$nodeListSize = newNodeSize;
				nodeList = $temp$nodeList;
				nodeListSize = $temp$nodeListSize;
				continue treeFromBuilder;
			}
		}
	});
var elm$core$Basics$add = _Basics_add;
var elm$core$Basics$apL = F2(
	function (f, x) {
		return f(x);
	});
var elm$core$Basics$floor = _Basics_floor;
var elm$core$Basics$gt = _Utils_gt;
var elm$core$Basics$max = F2(
	function (x, y) {
		return (_Utils_cmp(x, y) > 0) ? x : y;
	});
var elm$core$Basics$mul = _Basics_mul;
var elm$core$Basics$sub = _Basics_sub;
var elm$core$Elm$JsArray$length = _JsArray_length;
var elm$core$Array$builderToArray = F2(
	function (reverseNodeList, builder) {
		if (!builder.f) {
			return A4(
				elm$core$Array$Array_elm_builtin,
				elm$core$Elm$JsArray$length(builder.h),
				elm$core$Array$shiftStep,
				elm$core$Elm$JsArray$empty,
				builder.h);
		} else {
			var treeLen = builder.f * elm$core$Array$branchFactor;
			var depth = elm$core$Basics$floor(
				A2(elm$core$Basics$logBase, elm$core$Array$branchFactor, treeLen - 1));
			var correctNodeList = reverseNodeList ? elm$core$List$reverse(builder.i) : builder.i;
			var tree = A2(elm$core$Array$treeFromBuilder, correctNodeList, builder.f);
			return A4(
				elm$core$Array$Array_elm_builtin,
				elm$core$Elm$JsArray$length(builder.h) + treeLen,
				A2(elm$core$Basics$max, 5, depth * elm$core$Array$shiftStep),
				tree,
				builder.h);
		}
	});
var elm$core$Basics$False = 1;
var elm$core$Basics$idiv = _Basics_idiv;
var elm$core$Basics$lt = _Utils_lt;
var elm$core$Elm$JsArray$initialize = _JsArray_initialize;
var elm$core$Array$initializeHelp = F5(
	function (fn, fromIndex, len, nodeList, tail) {
		initializeHelp:
		while (true) {
			if (fromIndex < 0) {
				return A2(
					elm$core$Array$builderToArray,
					false,
					{i: nodeList, f: (len / elm$core$Array$branchFactor) | 0, h: tail});
			} else {
				var leaf = elm$core$Array$Leaf(
					A3(elm$core$Elm$JsArray$initialize, elm$core$Array$branchFactor, fromIndex, fn));
				var $temp$fn = fn,
					$temp$fromIndex = fromIndex - elm$core$Array$branchFactor,
					$temp$len = len,
					$temp$nodeList = A2(elm$core$List$cons, leaf, nodeList),
					$temp$tail = tail;
				fn = $temp$fn;
				fromIndex = $temp$fromIndex;
				len = $temp$len;
				nodeList = $temp$nodeList;
				tail = $temp$tail;
				continue initializeHelp;
			}
		}
	});
var elm$core$Basics$le = _Utils_le;
var elm$core$Basics$remainderBy = _Basics_remainderBy;
var elm$core$Array$initialize = F2(
	function (len, fn) {
		if (len <= 0) {
			return elm$core$Array$empty;
		} else {
			var tailLen = len % elm$core$Array$branchFactor;
			var tail = A3(elm$core$Elm$JsArray$initialize, tailLen, len - tailLen, fn);
			var initialFromIndex = (len - tailLen) - elm$core$Array$branchFactor;
			return A5(elm$core$Array$initializeHelp, fn, initialFromIndex, len, _List_Nil, tail);
		}
	});
var elm$core$Maybe$Just = function (a) {
	return {$: 0, a: a};
};
var elm$core$Maybe$Nothing = {$: 1};
var elm$core$Result$Err = function (a) {
	return {$: 1, a: a};
};
var elm$core$Result$Ok = function (a) {
	return {$: 0, a: a};
};
var elm$core$Basics$True = 0;
var elm$core$Result$isOk = function (result) {
	if (!result.$) {
		return true;
	} else {
		return false;
	}
};
var elm$json$Json$Decode$Failure = F2(
	function (a, b) {
		return {$: 3, a: a, b: b};
	});
var elm$json$Json$Decode$Field = F2(
	function (a, b) {
		return {$: 0, a: a, b: b};
	});
var elm$json$Json$Decode$Index = F2(
	function (a, b) {
		return {$: 1, a: a, b: b};
	});
var elm$json$Json$Decode$OneOf = function (a) {
	return {$: 2, a: a};
};
var elm$core$Basics$and = _Basics_and;
var elm$core$Basics$append = _Utils_append;
var elm$core$Basics$or = _Basics_or;
var elm$core$Char$toCode = _Char_toCode;
var elm$core$Char$isLower = function (_char) {
	var code = elm$core$Char$toCode(_char);
	return (97 <= code) && (code <= 122);
};
var elm$core$Char$isUpper = function (_char) {
	var code = elm$core$Char$toCode(_char);
	return (code <= 90) && (65 <= code);
};
var elm$core$Char$isAlpha = function (_char) {
	return elm$core$Char$isLower(_char) || elm$core$Char$isUpper(_char);
};
var elm$core$Char$isDigit = function (_char) {
	var code = elm$core$Char$toCode(_char);
	return (code <= 57) && (48 <= code);
};
var elm$core$Char$isAlphaNum = function (_char) {
	return elm$core$Char$isLower(_char) || (elm$core$Char$isUpper(_char) || elm$core$Char$isDigit(_char));
};
var elm$core$List$length = function (xs) {
	return A3(
		elm$core$List$foldl,
		F2(
			function (_n0, i) {
				return i + 1;
			}),
		0,
		xs);
};
var elm$core$List$map2 = _List_map2;
var elm$core$List$rangeHelp = F3(
	function (lo, hi, list) {
		rangeHelp:
		while (true) {
			if (_Utils_cmp(lo, hi) < 1) {
				var $temp$lo = lo,
					$temp$hi = hi - 1,
					$temp$list = A2(elm$core$List$cons, hi, list);
				lo = $temp$lo;
				hi = $temp$hi;
				list = $temp$list;
				continue rangeHelp;
			} else {
				return list;
			}
		}
	});
var elm$core$List$range = F2(
	function (lo, hi) {
		return A3(elm$core$List$rangeHelp, lo, hi, _List_Nil);
	});
var elm$core$List$indexedMap = F2(
	function (f, xs) {
		return A3(
			elm$core$List$map2,
			f,
			A2(
				elm$core$List$range,
				0,
				elm$core$List$length(xs) - 1),
			xs);
	});
var elm$core$String$all = _String_all;
var elm$core$String$fromInt = _String_fromNumber;
var elm$core$String$join = F2(
	function (sep, chunks) {
		return A2(
			_String_join,
			sep,
			_List_toArray(chunks));
	});
var elm$core$String$uncons = _String_uncons;
var elm$core$String$split = F2(
	function (sep, string) {
		return _List_fromArray(
			A2(_String_split, sep, string));
	});
var elm$json$Json$Decode$indent = function (str) {
	return A2(
		elm$core$String$join,
		'\n    ',
		A2(elm$core$String$split, '\n', str));
};
var elm$json$Json$Encode$encode = _Json_encode;
var elm$json$Json$Decode$errorOneOf = F2(
	function (i, error) {
		return '\n\n(' + (elm$core$String$fromInt(i + 1) + (') ' + elm$json$Json$Decode$indent(
			elm$json$Json$Decode$errorToString(error))));
	});
var elm$json$Json$Decode$errorToString = function (error) {
	return A2(elm$json$Json$Decode$errorToStringHelp, error, _List_Nil);
};
var elm$json$Json$Decode$errorToStringHelp = F2(
	function (error, context) {
		errorToStringHelp:
		while (true) {
			switch (error.$) {
				case 0:
					var f = error.a;
					var err = error.b;
					var isSimple = function () {
						var _n1 = elm$core$String$uncons(f);
						if (_n1.$ === 1) {
							return false;
						} else {
							var _n2 = _n1.a;
							var _char = _n2.a;
							var rest = _n2.b;
							return elm$core$Char$isAlpha(_char) && A2(elm$core$String$all, elm$core$Char$isAlphaNum, rest);
						}
					}();
					var fieldName = isSimple ? ('.' + f) : ('[\'' + (f + '\']'));
					var $temp$error = err,
						$temp$context = A2(elm$core$List$cons, fieldName, context);
					error = $temp$error;
					context = $temp$context;
					continue errorToStringHelp;
				case 1:
					var i = error.a;
					var err = error.b;
					var indexName = '[' + (elm$core$String$fromInt(i) + ']');
					var $temp$error = err,
						$temp$context = A2(elm$core$List$cons, indexName, context);
					error = $temp$error;
					context = $temp$context;
					continue errorToStringHelp;
				case 2:
					var errors = error.a;
					if (!errors.b) {
						return 'Ran into a Json.Decode.oneOf with no possibilities' + function () {
							if (!context.b) {
								return '!';
							} else {
								return ' at json' + A2(
									elm$core$String$join,
									'',
									elm$core$List$reverse(context));
							}
						}();
					} else {
						if (!errors.b.b) {
							var err = errors.a;
							var $temp$error = err,
								$temp$context = context;
							error = $temp$error;
							context = $temp$context;
							continue errorToStringHelp;
						} else {
							var starter = function () {
								if (!context.b) {
									return 'Json.Decode.oneOf';
								} else {
									return 'The Json.Decode.oneOf at json' + A2(
										elm$core$String$join,
										'',
										elm$core$List$reverse(context));
								}
							}();
							var introduction = starter + (' failed in the following ' + (elm$core$String$fromInt(
								elm$core$List$length(errors)) + ' ways:'));
							return A2(
								elm$core$String$join,
								'\n\n',
								A2(
									elm$core$List$cons,
									introduction,
									A2(elm$core$List$indexedMap, elm$json$Json$Decode$errorOneOf, errors)));
						}
					}
				default:
					var msg = error.a;
					var json = error.b;
					var introduction = function () {
						if (!context.b) {
							return 'Problem with the given value:\n\n';
						} else {
							return 'Problem with the value at json' + (A2(
								elm$core$String$join,
								'',
								elm$core$List$reverse(context)) + ':\n\n    ');
						}
					}();
					return introduction + (elm$json$Json$Decode$indent(
						A2(elm$json$Json$Encode$encode, 4, json)) + ('\n\n' + msg));
			}
		}
	});
var elm$json$Json$Encode$string = _Json_wrap;
var author$project$Cli$done = _Platform_outgoingPort('done', elm$json$Json$Encode$string);
var author$project$Destructuring$quote = function (txt) {
	return '\"' + (txt + '\"');
};
var elm$core$Bitwise$and = _Bitwise_and;
var elm$core$Bitwise$shiftRightBy = _Bitwise_shiftRightBy;
var elm$core$String$repeatHelp = F3(
	function (n, chunk, result) {
		return (n <= 0) ? result : A3(
			elm$core$String$repeatHelp,
			n >> 1,
			_Utils_ap(chunk, chunk),
			(!(n & 1)) ? result : _Utils_ap(result, chunk));
	});
var elm$core$String$repeat = F2(
	function (n, chunk) {
		return A3(elm$core$String$repeatHelp, n, chunk, '');
	});
var author$project$Destructuring$tab = F2(
	function (n, txt) {
		return _Utils_ap(
			A2(elm$core$String$repeat, 3 * n, ' '),
			txt);
	});
var elm$core$List$foldrHelper = F4(
	function (fn, acc, ctr, ls) {
		if (!ls.b) {
			return acc;
		} else {
			var a = ls.a;
			var r1 = ls.b;
			if (!r1.b) {
				return A2(fn, a, acc);
			} else {
				var b = r1.a;
				var r2 = r1.b;
				if (!r2.b) {
					return A2(
						fn,
						a,
						A2(fn, b, acc));
				} else {
					var c = r2.a;
					var r3 = r2.b;
					if (!r3.b) {
						return A2(
							fn,
							a,
							A2(
								fn,
								b,
								A2(fn, c, acc)));
					} else {
						var d = r3.a;
						var r4 = r3.b;
						var res = (ctr > 500) ? A3(
							elm$core$List$foldl,
							fn,
							acc,
							elm$core$List$reverse(r4)) : A4(elm$core$List$foldrHelper, fn, acc, ctr + 1, r4);
						return A2(
							fn,
							a,
							A2(
								fn,
								b,
								A2(
									fn,
									c,
									A2(fn, d, res))));
					}
				}
			}
		}
	});
var elm$core$List$foldr = F3(
	function (fn, acc, ls) {
		return A4(elm$core$List$foldrHelper, fn, acc, 0, ls);
	});
var elm$core$List$map = F2(
	function (f, xs) {
		return A3(
			elm$core$List$foldr,
			F2(
				function (x, acc) {
					return A2(
						elm$core$List$cons,
						f(x),
						acc);
				}),
			_List_Nil,
			xs);
	});
var author$project$Destructuring$tabLines = F2(
	function (n, txt) {
		return A2(
			elm$core$String$join,
			'\n',
			A2(
				elm$core$List$map,
				author$project$Destructuring$tab(n),
				A2(elm$core$String$split, '\n', txt)));
	});
var author$project$Decoder$decoderUnionSimple = F2(
	function (name, xs) {
		var constructor = function (_n0) {
			var a = _n0.a;
			var b = _n0.b;
			return _Utils_ap(
				author$project$Destructuring$quote(a) + '->\n',
				A2(author$project$Destructuring$tab, 2, 'Decode.succeed ' + a));
		};
		return A2(
			elm$core$String$join,
			'\n',
			A2(
				elm$core$List$map,
				author$project$Destructuring$tab(1),
				_Utils_ap(
					_List_fromArray(
						[
							'let',
							A2(author$project$Destructuring$tab, 1, 'recover x ='),
							A2(author$project$Destructuring$tab, 2, 'case x of')
						]),
					_Utils_ap(
						A2(
							elm$core$List$map,
							author$project$Destructuring$tabLines(3),
							A2(elm$core$List$map, constructor, xs)),
						_Utils_ap(
							_List_fromArray(
								[
									A2(author$project$Destructuring$tab, 3, 'other->'),
									A2(author$project$Destructuring$tab, 4, 'Decode.fail <| \"Unknown constructor for type ') + (name + ': \" ++ other')
								]),
							_List_fromArray(
								[
									'in',
									A2(author$project$Destructuring$tab, 1, 'Decode.string |> Decode.andThen recover')
								]))))));
	});
var author$project$Destructuring$bracket = function (txt) {
	return '(' + (txt + ')');
};
var author$project$Decoder$field = F4(
	function (n, name, dec, extra) {
		var _n0 = n < 9;
		if (_n0) {
			return author$project$Destructuring$bracket(' Decode.field ' + (name + (' ' + (dec + ' '))));
		} else {
			if (!extra) {
				return '|> Extra.andMap Decode.field(' + (name + (' ' + (dec + ')')));
			} else {
				return '|> Pipeline.required ' + (name + (' ' + dec));
			}
		}
	});
var author$project$Decoder$mapper = function (n) {
	var _n0 = n < 9;
	if (_n0) {
		var suffix = (n === 1) ? '' : elm$core$String$fromInt(n);
		return 'Decode.map' + suffix;
	} else {
		return 'Decode.succeed';
	}
};
var author$project$Decoder$var = function (n) {
	return 'a' + elm$core$String$fromInt(n);
};
var author$project$Decoder$varUpper = function (n) {
	return 'A' + elm$core$String$fromInt(n);
};
var elm$core$String$indices = _String_indexes;
var author$project$Destructuring$bracketIfSpaced = function (txt) {
	var _n0 = A2(elm$core$String$indices, ' ', txt);
	if (!_n0.b) {
		return txt;
	} else {
		var x = _n0.a;
		var xs = _n0.b;
		return author$project$Destructuring$bracket(txt);
	}
};
var elm$core$String$length = _String_length;
var elm$core$String$slice = _String_slice;
var elm$core$String$dropLeft = F2(
	function (n, string) {
		return (n < 1) ? string : A3(
			elm$core$String$slice,
			n,
			elm$core$String$length(string),
			string);
	});
var elm$core$String$left = F2(
	function (n, string) {
		return (n < 1) ? '' : A3(elm$core$String$slice, 0, n, string);
	});
var elm$core$String$toUpper = _String_toUpper;
var author$project$Destructuring$capitalize = function (txt) {
	return _Utils_ap(
		elm$core$String$toUpper(
			A2(elm$core$String$left, 1, txt)),
		A2(elm$core$String$dropLeft, 1, txt));
};
var elm$regex$Regex$Match = F4(
	function (match, index, number, submatches) {
		return {by: index, bB: match, bL: number, ba: submatches};
	});
var elm$regex$Regex$fromStringWith = _Regex_fromStringWith;
var elm$regex$Regex$fromString = function (string) {
	return A2(
		elm$regex$Regex$fromStringWith,
		{at: false, aP: false},
		string);
};
var elm$regex$Regex$replace = _Regex_replaceAtMost(_Regex_infinity);
var author$project$Destructuring$replace = F3(
	function (regexStr, fun, txt) {
		var _n0 = elm$regex$Regex$fromString(regexStr);
		if (_n0.$ === 1) {
			return txt;
		} else {
			var regexDef = _n0.a;
			return A3(elm$regex$Regex$replace, regexDef, fun, txt);
		}
	});
var author$project$Destructuring$replaceColons = A2(
	author$project$Destructuring$replace,
	'\\.',
	function (_n0) {
		return '_';
	});
var author$project$Destructuring$remove = F2(
	function (a, b) {
		return A3(
			author$project$Destructuring$replace,
			a,
			function (_n0) {
				return '';
			},
			b);
	});
var author$project$Destructuring$civilize = function (txt) {
	var to_ = A2(
		author$project$Destructuring$replace,
		'[(){}:,]',
		function (_n0) {
			return '_';
		});
	var deleteSpace = author$project$Destructuring$remove(' ');
	return to_(
		deleteSpace(txt));
};
var elm$core$String$concat = function (strings) {
	return A2(elm$core$String$join, '', strings);
};
var elm$core$Basics$negate = function (n) {
	return -n;
};
var elm$core$String$dropRight = F2(
	function (n, string) {
		return (n < 1) ? string : A3(elm$core$String$slice, 0, -n, string);
	});
var author$project$ParseType$typeDescr = F2(
	function (bracketIt, a) {
		var wrap = function (x) {
			return bracketIt ? ('(' + (x + ')')) : x;
		};
		switch (a.$) {
			case 0:
				var b = a.a;
				return wrap(
					'Array ' + A2(author$project$ParseType$typeDescr, true, b));
			case 1:
				return 'Bool';
			case 2:
				var _n1 = a.a;
				var b = _n1.a;
				var c = _n1.b;
				return 'Dict ' + (author$project$Destructuring$bracketIfSpaced(
					A2(author$project$ParseType$typeDescr, false, b)) + (' ' + author$project$Destructuring$bracketIfSpaced(
					A2(author$project$ParseType$typeDescr, false, c))));
			case 3:
				var b = a.a;
				return b;
			case 4:
				var b = a.a;
				var fieldString = function (x) {
					return x.ag + (': ' + (A2(author$project$ParseType$typeDescr, false, x.ao) + ', '));
				};
				var fields = A2(
					elm$core$String$dropRight,
					2,
					elm$core$String$concat(
						A2(elm$core$List$map, fieldString, b)));
				return '{' + (fields + '}');
			case 5:
				var b = a.a;
				var fieldString = function (x) {
					return x.ag + (': ' + (A2(author$project$ParseType$typeDescr, false, x.ao) + ', '));
				};
				var fields = A2(
					elm$core$String$dropRight,
					2,
					elm$core$String$concat(
						A2(elm$core$List$map, fieldString, b)));
				return '{ a | ' + (fields + '}');
			case 6:
				return 'Float';
			case 7:
				var b = a.a;
				return b;
			case 8:
				return 'Int';
			case 9:
				var b = a.a;
				return wrap(
					'List ' + A2(author$project$ParseType$typeDescr, true, b));
			case 10:
				var b = a.a;
				return wrap(
					'Maybe ' + A2(author$project$ParseType$typeDescr, true, b));
			case 11:
				var _n2 = a.a;
				var b = _n2.a;
				var c = _n2.b;
				if (!c.b) {
					return b;
				} else {
					return b + (' ' + elm$core$String$concat(
						A2(
							elm$core$List$map,
							author$project$ParseType$typeDescr(true),
							c)));
				}
			case 12:
				var b = a.a;
				var fieldString = function (x) {
					return x.ag + (': ' + (A2(author$project$ParseType$typeDescr, false, x.ao) + ', '));
				};
				var fields = A2(
					elm$core$String$dropRight,
					2,
					elm$core$String$concat(
						A2(elm$core$List$map, fieldString, b)));
				return '{' + (fields + '}');
			case 13:
				return 'String';
			case 14:
				var bs = a.a;
				return '(' + (A2(
					elm$core$String$join,
					', ',
					A2(
						elm$core$List$map,
						author$project$ParseType$typeDescr(false),
						bs)) + ')');
			default:
				var b = a.a;
				var constructorString = function (_n5) {
					var x = _n5.a;
					var y = _n5.b;
					if (!y.b) {
						return x + ' | ';
					} else {
						return x + (' ' + (elm$core$String$concat(
							A2(
								elm$core$List$map,
								author$project$ParseType$typeDescr(true),
								y)) + ' | '));
					}
				};
				var constructors = A2(
					elm$core$String$dropRight,
					2,
					elm$core$String$concat(
						A2(elm$core$List$map, constructorString, b)));
				return constructors;
		}
	});
var author$project$ParseType$typeNick = function (a) {
	var tag = function (prefix) {
		return _Utils_ap(
			prefix,
			author$project$Destructuring$civilize(
				A2(author$project$ParseType$typeDescr, false, a)));
	};
	switch (a.$) {
		case 4:
			return tag('Record');
		case 12:
			return tag('Record');
		case 14:
			return tag('Tuple');
		default:
			return tag('');
	}
};
var author$project$Types$TypeTuple = function (a) {
	return {$: 14, a: a};
};
var elm$core$Basics$neq = _Utils_notEqual;
var elm$core$List$filter = F2(
	function (isGood, list) {
		return A3(
			elm$core$List$foldr,
			F2(
				function (x, xs) {
					return isGood(x) ? A2(elm$core$List$cons, x, xs) : xs;
				}),
			_List_Nil,
			list);
	});
var elm$core$Tuple$pair = F2(
	function (a, b) {
		return _Utils_Tuple2(a, b);
	});
var author$project$Decoder$decoderHelp = F4(
	function (topLevel, rawName, a, extra) {
		var recurseOn = F2(
			function (x, y) {
				return x + (' ' + author$project$Destructuring$bracketIfSpaced(
					A4(author$project$Decoder$decoderHelp, false, '', y, extra)));
			});
		var name = author$project$Destructuring$replaceColons(rawName);
		switch (a.$) {
			case 0:
				var b = a.a;
				return A2(recurseOn, 'Decode.array', b);
			case 1:
				return 'Decode.bool';
			case 2:
				var _n8 = a.a;
				var b = _n8.a;
				var c = _n8.b;
				if (topLevel) {
					var subDecoderName = 'decode' + (name + 'Tuple');
					var subDecoder = A4(
						author$project$Decoder$decoderHelp,
						true,
						'',
						author$project$Types$TypeTuple(
							_List_fromArray(
								[b, c])),
						extra);
					return A2(
						elm$core$String$join,
						'\n',
						_List_fromArray(
							[
								'let',
								A2(author$project$Destructuring$tab, 1, subDecoderName + ' ='),
								A2(author$project$Destructuring$tabLines, 2, subDecoder),
								'in',
								A2(author$project$Destructuring$tab, 1, 'Decode.map Dict.fromList (Decode.list ' + (subDecoderName + ')'))
							]));
				} else {
					if (name === '') {
						return 'decode' + author$project$Destructuring$replaceColons(
							author$project$ParseType$typeNick(a));
					} else {
						return 'decode' + name;
					}
				}
			case 3:
				var b = a.a;
				return b;
			case 4:
				var b = a.a;
				if (topLevel) {
					if (name === '') {
						return A3(
							author$project$Decoder$decoderRecord,
							author$project$ParseType$typeNick(a),
							b,
							extra);
					} else {
						return A3(author$project$Decoder$decoderRecord, name + 'Extended', b, extra);
					}
				} else {
					if (name === '') {
						return 'decode' + author$project$ParseType$typeNick(a);
					} else {
						return 'decode' + (name + 'Extended');
					}
				}
			case 5:
				return '<< Extensible records are not decoded. >>';
			case 6:
				return 'Decode.float';
			case 7:
				var importedTypeReference = a.a;
				var _n14 = elm$core$List$reverse(
					A2(elm$core$String$split, '.', importedTypeReference));
				if (_n14.b) {
					var typeName = _n14.a;
					var reversedPath = _n14.b;
					var path = function () {
						if (!reversedPath.b) {
							return '';
						} else {
							return A2(
								elm$core$String$join,
								'.',
								elm$core$List$reverse(reversedPath)) + '.';
						}
					}();
					return path + ('decode' + typeName);
				} else {
					return 'decode' + name;
				}
			case 8:
				return 'Decode.int';
			case 9:
				var b = a.a;
				return A2(recurseOn, 'Decode.list', b);
			case 10:
				var b = a.a;
				return A2(recurseOn, 'Decode.maybe', b);
			case 11:
				var b = a.a;
				if (topLevel) {
					return A3(author$project$Decoder$decoderProduct, true, b, extra);
				} else {
					if (name === '') {
						return 'decode' + author$project$ParseType$typeNick(a);
					} else {
						return 'decode' + name;
					}
				}
			case 12:
				var b = a.a;
				if (topLevel) {
					if (name === '') {
						return A3(
							author$project$Decoder$decoderRecord,
							author$project$ParseType$typeNick(a),
							b,
							extra);
					} else {
						return A3(author$project$Decoder$decoderRecord, name, b, extra);
					}
				} else {
					if (name === '') {
						return 'decode' + author$project$ParseType$typeNick(a);
					} else {
						return 'decode' + name;
					}
				}
			case 13:
				return 'Decode.string';
			case 14:
				var bs = a.a;
				if (topLevel) {
					return A2(author$project$Decoder$decoderTuple, bs, extra);
				} else {
					if (name === '') {
						return 'decode' + author$project$ParseType$typeNick(a);
					} else {
						return 'decode' + name;
					}
				}
			default:
				var b = a.a;
				if (topLevel) {
					return A3(author$project$Decoder$decoderUnion, name, b, extra);
				} else {
					if (name === '') {
						var folder = F2(
							function (x, y) {
								return x + (', ' + y);
							});
						var typeStr = '{ ' + (A3(
							elm$core$List$foldl,
							folder,
							'',
							A2(elm$core$List$map, elm$core$Tuple$first, b)) + ' }');
						return 'Decoder parse error: anonymous union type: ' + typeStr;
					} else {
						return 'decode' + name;
					}
				}
		}
	});
var author$project$Decoder$decoderProduct = F3(
	function (productType, _n4, extra) {
		var constructor = _n4.a;
		var subTypes = _n4.b;
		var varNum = elm$core$List$length(subTypes);
		var vars = A2(
			elm$core$List$map,
			author$project$Decoder$var,
			A2(elm$core$List$range, 1, varNum));
		var subDecoder = function (a) {
			return author$project$Destructuring$bracketIfSpaced(
				A4(author$project$Decoder$decoderHelp, false, '', a, extra));
		};
		var simpleDecoder = function (x) {
			return 'Decode.map ' + (constructor + (' ' + subDecoder(x)));
		};
		var fieldDefs = A3(
			elm$core$List$map2,
			F2(
				function (a, b) {
					return _Utils_Tuple2(a, b);
				}),
			vars,
			subTypes);
		var fieldDecode = function (_n6) {
			var a = _n6.a;
			var b = _n6.b;
			return A4(
				author$project$Decoder$field,
				varNum,
				author$project$Destructuring$quote(
					author$project$Destructuring$capitalize(a)),
				subDecoder(b),
				extra);
		};
		var complexDecoder = A2(
			elm$core$String$join,
			'\n',
			_Utils_ap(
				_List_fromArray(
					[
						author$project$Decoder$mapper(varNum),
						A2(author$project$Destructuring$tab, 1, constructor)
					]),
				A2(
					elm$core$List$map,
					author$project$Destructuring$tab(2),
					A2(elm$core$List$map, fieldDecode, fieldDefs))));
		if (!subTypes.b) {
			return 'Decode.succeed ' + constructor;
		} else {
			if (!subTypes.b.b) {
				var x = subTypes.a;
				return productType ? simpleDecoder(x) : complexDecoder;
			} else {
				return complexDecoder;
			}
		}
	});
var author$project$Decoder$decoderRecord = F3(
	function (name, xs, extra) {
		var subDecoder = function (x) {
			return author$project$Destructuring$bracketIfSpaced(
				A4(author$project$Decoder$decoderHelp, false, '', x, extra));
		};
		var fieldNum = elm$core$List$length(xs);
		var fieldDecode = function (x) {
			return A4(
				author$project$Decoder$field,
				fieldNum,
				author$project$Destructuring$quote(x.ag),
				subDecoder(x.ao),
				extra);
		};
		return A2(
			elm$core$String$join,
			'\n',
			_Utils_ap(
				_List_fromArray(
					[
						author$project$Decoder$mapper(fieldNum),
						A2(author$project$Destructuring$tab, 1, name)
					]),
				A2(
					elm$core$List$map,
					author$project$Destructuring$tab(2),
					A2(elm$core$List$map, fieldDecode, xs))));
	});
var author$project$Decoder$decoderTuple = F2(
	function (xs, extra) {
		var varNum = elm$core$List$length(xs);
		var vars = A2(
			elm$core$List$map,
			author$project$Decoder$var,
			A2(elm$core$List$range, 1, varNum));
		var varListComma = '(' + (A2(elm$core$String$join, ', ', vars) + ')');
		var varList = A2(elm$core$String$join, ' ', vars);
		var toTuple = '(\\' + (varList + (' -> ' + (varListComma + ')')));
		var subDecoder = function (x) {
			return author$project$Destructuring$bracketIfSpaced(
				A4(author$project$Decoder$decoderHelp, false, '', x, extra));
		};
		var component = function (_n3) {
			var idx = _n3.a;
			var elem = _n3.b;
			return A2(
				author$project$Destructuring$tab,
				2,
				A4(
					author$project$Decoder$field,
					varNum,
					author$project$Destructuring$quote(
						author$project$Decoder$varUpper(idx + 1)),
					subDecoder(elem),
					extra));
		};
		return author$project$Decoder$mapper(varNum) + ('\n' + (A2(author$project$Destructuring$tab, 1, toTuple) + ('\n' + A2(
			elm$core$String$join,
			'\n',
			A2(
				elm$core$List$map,
				component,
				A2(elm$core$List$indexedMap, elm$core$Tuple$pair, xs))))));
	});
var author$project$Decoder$decoderUnion = F3(
	function (name, xs, extra) {
		var complexConstructor = function (_n2) {
			var a = _n2.a;
			var b = _n2.b;
			return !_Utils_eq(b, _List_Nil);
		};
		var simpleUnion = _Utils_eq(
			A2(elm$core$List$filter, complexConstructor, xs),
			_List_Nil);
		if (simpleUnion) {
			return A2(author$project$Decoder$decoderUnionSimple, name, xs);
		} else {
			return A3(author$project$Decoder$decoderUnionComplex, name, xs, extra);
		}
	});
var author$project$Decoder$decoderUnionComplex = F3(
	function (name, xs, extra) {
		var decodeConstructor = function (_n0) {
			var constructor = _n0.a;
			var fields = _n0.b;
			return author$project$Destructuring$quote(constructor) + (' ->\n' + A2(
				author$project$Destructuring$tabLines,
				1,
				A3(
					author$project$Decoder$decoderProduct,
					false,
					_Utils_Tuple2(constructor, fields),
					extra)));
		};
		return A2(
			elm$core$String$join,
			'\n',
			_Utils_ap(
				_List_fromArray(
					[
						A2(
						author$project$Destructuring$tab,
						1,
						'Decode.field \"Constructor\" Decode.string |> Decode.andThen decode' + (author$project$Destructuring$replaceColons(name) + ('Help' + '\n'))),
						'decode' + (author$project$Destructuring$replaceColons(name) + 'Help constructor ='),
						A2(author$project$Destructuring$tab, 1, 'case constructor of')
					]),
				_Utils_ap(
					A2(
						elm$core$List$map,
						author$project$Destructuring$tabLines(2),
						A2(elm$core$List$map, decodeConstructor, xs)),
					_List_fromArray(
						[
							A2(author$project$Destructuring$tab, 2, 'other->'),
							A2(author$project$Destructuring$tab, 3, 'Decode.fail <| \"Unknown constructor for type ' + (name + ': \" ++ other'))
						]))));
	});
var author$project$Decoder$decoder = F2(
	function (extra, typeDef) {
		var decoderName = 'decode' + (author$project$Destructuring$replaceColons(typeDef.ag) + ' =');
		var decoderBodyRaw = A2(
			elm$core$String$split,
			'\n',
			A4(author$project$Decoder$decoderHelp, true, typeDef.ag, typeDef.ao, extra));
		var decoderBody = function () {
			var _n0 = typeDef.ao;
			if (_n0.$ === 15) {
				return decoderBodyRaw;
			} else {
				return A2(
					elm$core$List$map,
					author$project$Destructuring$tab(1),
					decoderBodyRaw);
			}
		}();
		return A2(elm$core$List$cons, decoderName, decoderBody);
	});
var author$project$Destructuring$stringify = function (xs) {
	return A2(
		elm$core$String$join,
		'\n\n',
		A2(
			elm$core$List$map,
			elm$core$String$join('\n'),
			xs));
};
var author$project$ParseType$aliasDefs = function (types) {
	var name = function (a) {
		var _n0 = a.ao;
		if (_n0.$ === 4) {
			return a.ag + 'Extended';
		} else {
			return a.ag;
		}
	};
	var def = function (a) {
		return _List_fromArray(
			[
				'type alias ' + (name(a) + (' = ' + A2(author$project$ParseType$typeDescr, true, a.ao)))
			]);
	};
	return A2(elm$core$List$map, def, types);
};
var author$project$Types$TypeMaybe = function (a) {
	return {$: 10, a: a};
};
var elm$core$Basics$composeL = F3(
	function (g, f, x) {
		return g(
			f(x));
	});
var elm$core$Basics$identity = function (x) {
	return x;
};
var elm$core$List$append = F2(
	function (xs, ys) {
		if (!ys.b) {
			return xs;
		} else {
			return A3(elm$core$List$foldr, elm$core$List$cons, ys, xs);
		}
	});
var elm$core$List$concat = function (lists) {
	return A3(elm$core$List$foldr, elm$core$List$append, _List_Nil, lists);
};
var author$project$AnonymousTypes$anonymousHelp = F3(
	function (topLevel, a, xs) {
		anonymousHelp:
		while (true) {
			switch (a.$) {
				case 0:
					var b = a.a;
					var $temp$topLevel = false,
						$temp$a = b,
						$temp$xs = xs;
					topLevel = $temp$topLevel;
					a = $temp$a;
					xs = $temp$xs;
					continue anonymousHelp;
				case 1:
					return xs;
				case 2:
					var _n1 = a.a;
					var b = _n1.a;
					var c = _n1.b;
					var recurseOn = A2(
						elm$core$Basics$composeL,
						A2(author$project$AnonymousTypes$anonymousHelp, false, b),
						A2(author$project$AnonymousTypes$anonymousHelp, false, c));
					if (topLevel) {
						return recurseOn(xs);
					} else {
						return recurseOn(
							A2(elm$core$List$cons, a, xs));
					}
				case 3:
					var b = a.a;
					return xs;
				case 4:
					var b = a.a;
					var recurseOn = A3(
						elm$core$List$foldr,
						elm$core$Basics$composeL,
						elm$core$Basics$identity,
						A2(
							elm$core$List$map,
							author$project$AnonymousTypes$anonymousHelp(false),
							A2(
								elm$core$List$map,
								function ($) {
									return $.ao;
								},
								b)));
					if (topLevel) {
						return recurseOn(xs);
					} else {
						return recurseOn(
							A2(elm$core$List$cons, a, xs));
					}
				case 5:
					return xs;
				case 6:
					return xs;
				case 7:
					var b = a.a;
					return xs;
				case 8:
					return xs;
				case 9:
					var b = a.a;
					var $temp$topLevel = false,
						$temp$a = b,
						$temp$xs = xs;
					topLevel = $temp$topLevel;
					a = $temp$a;
					xs = $temp$xs;
					continue anonymousHelp;
				case 10:
					var b = a.a;
					if (topLevel) {
						var $temp$topLevel = false,
							$temp$a = b,
							$temp$xs = xs;
						topLevel = $temp$topLevel;
						a = $temp$a;
						xs = $temp$xs;
						continue anonymousHelp;
					} else {
						var $temp$topLevel = false,
							$temp$a = b,
							$temp$xs = A2(
							elm$core$List$cons,
							author$project$Types$TypeMaybe(b),
							xs);
						topLevel = $temp$topLevel;
						a = $temp$a;
						xs = $temp$xs;
						continue anonymousHelp;
					}
				case 11:
					var _n5 = a.a;
					var b = _n5.a;
					var c = _n5.b;
					if (!c.b) {
						return xs;
					} else {
						return A3(
							elm$core$List$foldr,
							elm$core$Basics$composeL,
							elm$core$Basics$identity,
							A2(
								elm$core$List$map,
								author$project$AnonymousTypes$anonymousHelp(false),
								c))(xs);
					}
				case 12:
					var b = a.a;
					var recurseOn = A3(
						elm$core$List$foldr,
						elm$core$Basics$composeL,
						elm$core$Basics$identity,
						A2(
							elm$core$List$map,
							author$project$AnonymousTypes$anonymousHelp(false),
							A2(
								elm$core$List$map,
								function ($) {
									return $.ao;
								},
								b)));
					if (topLevel) {
						return recurseOn(xs);
					} else {
						return recurseOn(
							A2(elm$core$List$cons, a, xs));
					}
				case 13:
					return xs;
				case 14:
					var bs = a.a;
					var recurseOn = A3(
						elm$core$List$foldr,
						elm$core$Basics$composeL,
						elm$core$Basics$identity,
						A2(
							elm$core$List$map,
							author$project$AnonymousTypes$anonymousHelp(false),
							bs));
					if (topLevel) {
						return recurseOn(xs);
					} else {
						return recurseOn(
							A2(elm$core$List$cons, a, xs));
					}
				default:
					var b = a.a;
					var typeList = elm$core$List$concat(
						A2(
							elm$core$List$map,
							function (_n9) {
								var x = _n9.a;
								var y = _n9.b;
								return y;
							},
							b));
					return A3(
						elm$core$List$foldr,
						elm$core$Basics$composeL,
						elm$core$Basics$identity,
						A2(
							elm$core$List$map,
							author$project$AnonymousTypes$anonymousHelp(false),
							typeList))(xs);
			}
		}
	});
var author$project$AnonymousTypes$anonymous = function (typeDef) {
	return A3(author$project$AnonymousTypes$anonymousHelp, true, typeDef.ao, _List_Nil);
};
var elm$core$List$any = F2(
	function (isOkay, list) {
		any:
		while (true) {
			if (!list.b) {
				return false;
			} else {
				var x = list.a;
				var xs = list.b;
				if (isOkay(x)) {
					return true;
				} else {
					var $temp$isOkay = isOkay,
						$temp$list = xs;
					isOkay = $temp$isOkay;
					list = $temp$list;
					continue any;
				}
			}
		}
	});
var author$project$AnonymousTypes$uniqueHelp = F2(
	function (checked, remaining) {
		uniqueHelp:
		while (true) {
			if (!remaining.b) {
				return checked;
			} else {
				var x = remaining.a;
				var xs = remaining.b;
				var _n1 = A2(
					elm$core$List$any,
					function (a) {
						return _Utils_eq(a, x);
					},
					_Utils_ap(checked, xs));
				if (!_n1) {
					var $temp$checked = A2(elm$core$List$cons, x, checked),
						$temp$remaining = xs;
					checked = $temp$checked;
					remaining = $temp$remaining;
					continue uniqueHelp;
				} else {
					var $temp$checked = checked,
						$temp$remaining = xs;
					checked = $temp$checked;
					remaining = $temp$remaining;
					continue uniqueHelp;
				}
			}
		}
	});
var author$project$AnonymousTypes$unique = function (xs) {
	return A2(author$project$AnonymousTypes$uniqueHelp, _List_Nil, xs);
};
var author$project$Types$simpleType = function (_this) {
	switch (_this.$) {
		case 1:
			return true;
		case 6:
			return true;
		case 8:
			return true;
		case 13:
			return true;
		default:
			return false;
	}
};
var author$project$Types$coreType = function (_this) {
	switch (_this.$) {
		case 0:
			var a = _this.a;
			return author$project$Types$simpleType(a);
		case 9:
			var a = _this.a;
			return author$project$Types$simpleType(a);
		case 10:
			var a = _this.a;
			return author$project$Types$simpleType(a);
		default:
			return author$project$Types$simpleType(_this);
	}
};
var author$project$Types$coreTypeForEncoding = function (_this) {
	if (_this.$ === 10) {
		return false;
	} else {
		return author$project$Types$coreType(_this);
	}
};
var elm$core$Basics$not = _Basics_not;
var author$project$AnonymousTypes$grabAnonymousTypes = F2(
	function (encoding, typeDefs) {
		var notMaybe = function (a) {
			if (a.$ === 10) {
				return false;
			} else {
				return true;
			}
		};
		var typeFilter = function () {
			if (encoding) {
				return elm$core$List$filter(
					A2(elm$core$Basics$composeL, elm$core$Basics$not, author$project$Types$coreTypeForEncoding));
			} else {
				return A2(
					elm$core$Basics$composeL,
					elm$core$List$filter(notMaybe),
					elm$core$List$filter(
						A2(elm$core$Basics$composeL, elm$core$Basics$not, author$project$Types$coreType)));
			}
		}();
		return typeFilter(
			author$project$AnonymousTypes$unique(
				elm$core$List$concat(
					A2(elm$core$List$map, author$project$AnonymousTypes$anonymous, typeDefs))));
	});
var author$project$ParseType$anonymousType = function (a) {
	return {
		ag: author$project$Destructuring$replaceColons(
			author$project$ParseType$typeNick(a)),
		ao: a
	};
};
var author$project$ParseType$anonymousTypes = F2(
	function (encoding, typeList) {
		return A2(
			elm$core$List$map,
			author$project$ParseType$anonymousType,
			A2(author$project$AnonymousTypes$grabAnonymousTypes, encoding, typeList));
	});
var author$project$ParseType$extensibleFields = F2(
	function (allTypDefs, name) {
		var candidate = function (x) {
			return _Utils_eq(x.ag, name);
		};
		var _n0 = A2(elm$core$List$filter, candidate, allTypDefs);
		if (_n0.b) {
			var x = _n0.a;
			var _n1 = x.ao;
			if (_n1.$ === 5) {
				var fields = _n1.a;
				return elm$core$Maybe$Just(fields);
			} else {
				return elm$core$Maybe$Nothing;
			}
		} else {
			return elm$core$Maybe$Nothing;
		}
	});
var author$project$Types$TypeArray = function (a) {
	return {$: 0, a: a};
};
var author$project$Types$TypeDict = function (a) {
	return {$: 2, a: a};
};
var author$project$Types$TypeExtendedRecord = function (a) {
	return {$: 4, a: a};
};
var author$project$Types$TypeExtensible = function (a) {
	return {$: 5, a: a};
};
var author$project$Types$TypeList = function (a) {
	return {$: 9, a: a};
};
var author$project$Types$TypeRecord = function (a) {
	return {$: 12, a: a};
};
var author$project$Types$TypeUnion = function (a) {
	return {$: 15, a: a};
};
var author$project$ParseType$detectExtendedRecord = F2(
	function (declaredTypes, input) {
		var newType = A3(author$project$ParseType$detectExtendedRecordHelp, declaredTypes, _List_Nil, input.ao);
		return _Utils_update(
			input,
			{ao: newType});
	});
var author$project$ParseType$detectExtendedRecordHelp = F3(
	function (declaredTypes, fieldsSoFar, input) {
		var recursion = F2(
			function (a, b) {
				return A3(author$project$ParseType$detectExtendedRecordHelp, declaredTypes, a, b);
			});
		var lookInto = function (a) {
			return A2(author$project$ParseType$detectExtendedRecord, declaredTypes, a);
		};
		var lookAt = function (a) {
			return A3(author$project$ParseType$detectExtendedRecordHelp, declaredTypes, _List_Nil, a);
		};
		var extensiblesFor = function (a) {
			return A2(author$project$ParseType$extensibleFields, declaredTypes, a);
		};
		_n0$10:
		while (true) {
			switch (input.$) {
				case 0:
					var ofType = input.a;
					return author$project$Types$TypeArray(
						lookAt(ofType));
				case 2:
					var _n1 = input.a;
					var key = _n1.a;
					var val = _n1.b;
					return author$project$Types$TypeDict(
						_Utils_Tuple2(
							key,
							lookAt(val)));
				case 4:
					var fields = input.a;
					return author$project$Types$TypeExtendedRecord(
						A2(elm$core$List$map, lookInto, fields));
				case 5:
					var fields = input.a;
					return author$project$Types$TypeExtensible(
						A2(elm$core$List$map, lookInto, fields));
				case 9:
					var ofType = input.a;
					return author$project$Types$TypeList(
						lookAt(ofType));
				case 10:
					var ofType = input.a;
					return author$project$Types$TypeMaybe(
						lookAt(ofType));
				case 11:
					if (input.a.b.b && (!input.a.b.b.b)) {
						var _n2 = input.a;
						var constructor = _n2.a;
						var _n3 = _n2.b;
						var subType = _n3.a;
						var _n4 = extensiblesFor(constructor);
						if (!_n4.$) {
							var extensibles = _n4.a;
							switch (subType.$) {
								case 12:
									var newFields = subType.a;
									return author$project$Types$TypeExtendedRecord(
										_Utils_ap(
											fieldsSoFar,
											A2(
												elm$core$List$map,
												lookInto,
												_Utils_ap(extensibles, newFields))));
								case 11:
									return A2(
										recursion,
										_Utils_ap(fieldsSoFar, extensibles),
										subType);
								default:
									return input;
							}
						} else {
							return input;
						}
					} else {
						break _n0$10;
					}
				case 12:
					var newFields = input.a;
					if (!fieldsSoFar.b) {
						return author$project$Types$TypeRecord(
							A2(elm$core$List$map, lookInto, newFields));
					} else {
						return author$project$Types$TypeExtendedRecord(
							_Utils_ap(
								fieldsSoFar,
								A2(elm$core$List$map, lookInto, newFields)));
					}
				case 14:
					var typeList = input.a;
					return author$project$Types$TypeTuple(
						A2(elm$core$List$map, lookAt, typeList));
				case 15:
					var list = input.a;
					var mapper = function (_n7) {
						var constructor = _n7.a;
						var subTypes = _n7.b;
						return _Utils_Tuple2(
							constructor,
							A2(elm$core$List$map, lookAt, subTypes));
					};
					return author$project$Types$TypeUnion(
						A2(elm$core$List$map, mapper, list));
				default:
					break _n0$10;
			}
		}
		return input;
	});
var author$project$Destructuring$decomment = function (txt) {
	var singleComment = '--.*';
	var multiComment = '\\{\\-(.|\\n)*?\\-\\}';
	return A2(
		author$project$Destructuring$remove,
		singleComment,
		A2(author$project$Destructuring$remove, multiComment, txt));
};
var elm$regex$Regex$find = _Regex_findAtMost(_Regex_infinity);
var author$project$Destructuring$regex = F2(
	function (regexStr, txt) {
		var _n0 = elm$regex$Regex$fromString(regexStr);
		if (_n0.$ === 1) {
			return _List_Nil;
		} else {
			var regexDef = _n0.a;
			return A2(elm$regex$Regex$find, regexDef, txt);
		}
	});
var author$project$Destructuring$removeNothings = function (xs) {
	var dropJust = function (a) {
		if (a.$ === 1) {
			return _List_Nil;
		} else {
			var b = a.a;
			return _List_fromArray(
				[b]);
		}
	};
	return elm$core$List$concat(
		A2(elm$core$List$map, dropJust, xs));
};
var author$project$Destructuring$removeStringLiterals = function (txt) {
	return A2(
		author$project$Destructuring$remove,
		'\".*?\"',
		A2(author$project$Destructuring$remove, '\"\"\"(?:\\n|.)+?\"\"\"', txt));
};
var author$project$Destructuring$singleSpace = function (txt) {
	return A3(
		author$project$Destructuring$replace,
		'[ ]+',
		function (_n0) {
			return ' ';
		},
		txt);
};
var author$project$Destructuring$singleLine = function (txt) {
	return author$project$Destructuring$singleSpace(
		A3(
			author$project$Destructuring$replace,
			'[\\r\\n]',
			function (a) {
				return ' ';
			},
			txt));
};
var elm$core$String$trim = _String_trim;
var elm$core$String$words = _String_words;
var author$project$ParseType$grabRawType = function (submatches) {
	if (((submatches.b && (!submatches.a.$)) && submatches.b.b) && (!submatches.b.a.$)) {
		var a = submatches.a.a;
		var _n1 = submatches.b;
		var b = _n1.a.a;
		var _n2 = elm$core$String$words(
			elm$core$String$trim(a));
		if (_n2.b) {
			if (_n2.b.b) {
				var x = _n2.a;
				var _n3 = _n2.b;
				var y = _n3.a;
				return elm$core$Maybe$Just(
					{
						ac: elm$core$String$trim(
							author$project$Destructuring$singleLine(b)),
						ae: true,
						ag: x
					});
			} else {
				var x = _n2.a;
				return elm$core$Maybe$Just(
					{
						ac: elm$core$String$trim(
							author$project$Destructuring$singleLine(b)),
						ae: false,
						ag: x
					});
			}
		} else {
			return elm$core$Maybe$Nothing;
		}
	} else {
		return elm$core$Maybe$Nothing;
	}
};
var author$project$ParseType$typeRegex = 'type\\s+(?:alias\\s+)?([\\w_]+[\\w_\\s]*)=([\\w(){},|.:_ \\r\\n]+)(?=(?:\\r\\w|\\n\\w)|$)';
var author$project$ParseType$grabRawTypes = function (txt) {
	return author$project$Destructuring$removeNothings(
		A2(
			elm$core$List$map,
			author$project$ParseType$grabRawType,
			A2(
				elm$core$List$map,
				function ($) {
					return $.ba;
				},
				A2(
					author$project$Destructuring$regex,
					author$project$ParseType$typeRegex,
					author$project$Destructuring$decomment(
						author$project$Destructuring$removeStringLiterals(txt))))));
};
var elm$core$String$right = F2(
	function (n, string) {
		return (n < 1) ? '' : A3(
			elm$core$String$slice,
			-n,
			elm$core$String$length(string),
			string);
	});
var author$project$Destructuring$debracket = function (txt) {
	var trimmed = elm$core$String$trim(txt);
	return ((A2(elm$core$String$left, 1, trimmed) === '(') && (A2(elm$core$String$right, 1, trimmed) === ')')) ? elm$core$String$trim(
		A2(
			elm$core$String$dropLeft,
			1,
			A2(elm$core$String$dropRight, 1, trimmed))) : trimmed;
};
var author$project$Destructuring$occurs = F2(
	function (a, txt) {
		return elm$core$List$length(
			A2(elm$core$String$indices, a, txt));
	});
var author$project$Destructuring$outside = F4(
	function (a, b, idx, txt) {
		var chunk = A2(elm$core$String$left, idx, txt);
		return _Utils_eq(
			A2(author$project$Destructuring$occurs, a, chunk),
			A2(author$project$Destructuring$occurs, b, chunk));
	});
var author$project$Destructuring$outsideBrackets = function (txt) {
	return A3(author$project$Destructuring$outside, '(', ')', txt);
};
var author$project$Destructuring$outsideCurly = function (txt) {
	return A3(author$project$Destructuring$outside, '{', '}', txt);
};
var author$project$Destructuring$dropWord = F2(
	function (word, txt) {
		return elm$core$String$trim(
			A2(
				elm$core$String$dropLeft,
				elm$core$String$length(word) + 1,
				txt));
	});
var author$project$Destructuring$toField = function (def) {
	var _n0 = A2(elm$core$String$split, ':', def);
	if (_n0.b) {
		var x = _n0.a;
		var xs = _n0.b;
		return elm$core$Maybe$Just(
			_Utils_Tuple2(
				elm$core$String$trim(x),
				A2(author$project$Destructuring$dropWord, x, def)));
	} else {
		return elm$core$Maybe$Nothing;
	}
};
var author$project$Destructuring$derecordHelp = F2(
	function (idxs, txt) {
		derecordHelp:
		while (true) {
			if (!idxs.b) {
				var _n1 = author$project$Destructuring$toField(txt);
				if (!_n1.$) {
					var _n2 = _n1.a;
					var a = _n2.a;
					var b = _n2.b;
					return _List_fromArray(
						[
							_Utils_Tuple2(a, b)
						]);
				} else {
					return _List_Nil;
				}
			} else {
				var x = idxs.a;
				var xs = idxs.b;
				var _n3 = A2(author$project$Destructuring$outsideBrackets, x, txt) && A2(author$project$Destructuring$outsideCurly, x, txt);
				if (_n3) {
					var remains = A2(elm$core$String$dropLeft, x + 1, txt);
					var newIdxs = A2(elm$core$String$indices, ',', remains);
					var _n4 = author$project$Destructuring$toField(
						A2(elm$core$String$left, x, txt));
					if (!_n4.$) {
						var _n5 = _n4.a;
						var a = _n5.a;
						var b = _n5.b;
						return A2(
							elm$core$List$cons,
							_Utils_Tuple2(a, b),
							A2(author$project$Destructuring$derecordHelp, newIdxs, remains));
					} else {
						var $temp$idxs = newIdxs,
							$temp$txt = remains;
						idxs = $temp$idxs;
						txt = $temp$txt;
						continue derecordHelp;
					}
				} else {
					var $temp$idxs = xs,
						$temp$txt = txt;
					idxs = $temp$idxs;
					txt = $temp$txt;
					continue derecordHelp;
				}
			}
		}
	});
var author$project$Destructuring$inThese = F3(
	function (a, b, txt) {
		var trimmed = elm$core$String$trim(txt);
		return (_Utils_eq(
			A2(elm$core$String$left, 1, trimmed),
			a) && _Utils_eq(
			A2(elm$core$String$right, 1, trimmed),
			b)) ? elm$core$Maybe$Just(
			A2(
				elm$core$String$dropLeft,
				1,
				A2(elm$core$String$dropRight, 1, trimmed))) : elm$core$Maybe$Nothing;
	});
var author$project$Destructuring$inCurly = function (txt) {
	return A3(author$project$Destructuring$inThese, '{', '}', txt);
};
var author$project$Destructuring$derecord = function (txt) {
	var _n0 = author$project$Destructuring$inCurly(txt);
	if (_n0.$ === 1) {
		return _List_Nil;
	} else {
		var x = _n0.a;
		var y = elm$core$String$trim(
			A2(author$project$Destructuring$remove, '^.*\\|', x));
		return A2(
			author$project$Destructuring$derecordHelp,
			A2(elm$core$String$indices, ',', y),
			y);
	}
};
var author$project$Destructuring$detupleHelp = F3(
	function (idxs, txt, elements) {
		detupleHelp:
		while (true) {
			if (!idxs.b) {
				if (!elements.b) {
					return _List_Nil;
				} else {
					var x = elements.a;
					var xs = elements.b;
					return _Utils_ap(
						elements,
						_List_fromArray(
							[txt]));
				}
			} else {
				var x = idxs.a;
				var xs = idxs.b;
				var _n2 = A2(author$project$Destructuring$outsideBrackets, x, txt) && A2(author$project$Destructuring$outsideCurly, x, txt);
				if (_n2) {
					var newTxt = A2(elm$core$String$dropLeft, x + 1, txt);
					var $temp$idxs = A2(elm$core$String$indices, ',', newTxt),
						$temp$txt = newTxt,
						$temp$elements = _Utils_ap(
						elements,
						_List_fromArray(
							[
								A2(elm$core$String$left, x, txt)
							]));
					idxs = $temp$idxs;
					txt = $temp$txt;
					elements = $temp$elements;
					continue detupleHelp;
				} else {
					var $temp$idxs = xs,
						$temp$txt = txt,
						$temp$elements = elements;
					idxs = $temp$idxs;
					txt = $temp$txt;
					elements = $temp$elements;
					continue detupleHelp;
				}
			}
		}
	});
var author$project$Destructuring$inBrackets = function (txt) {
	return A3(author$project$Destructuring$inThese, '(', ')', txt);
};
var author$project$Destructuring$detuple = function (txt) {
	var _n0 = author$project$Destructuring$inBrackets(txt);
	if (_n0.$ === 1) {
		return _List_Nil;
	} else {
		var x = _n0.a;
		return A3(
			author$project$Destructuring$detupleHelp,
			A2(elm$core$String$indices, ',', x),
			x,
			_List_Nil);
	}
};
var author$project$Destructuring$componentsHelp = F3(
	function (idxs, start, txt) {
		componentsHelp:
		while (true) {
			if (!idxs.b) {
				return _List_fromArray(
					[
						A2(elm$core$String$dropLeft, start, txt)
					]);
			} else {
				var x = idxs.a;
				var xs = idxs.b;
				var _n1 = A2(author$project$Destructuring$outsideBrackets, x, txt) && A2(author$project$Destructuring$outsideCurly, x, txt);
				if (_n1) {
					var newStart = x + 1;
					var component = A2(
						elm$core$String$dropLeft,
						start,
						A2(elm$core$String$left, x, txt));
					return A2(
						elm$core$List$cons,
						component,
						A3(author$project$Destructuring$componentsHelp, xs, newStart, txt));
				} else {
					var $temp$idxs = xs,
						$temp$start = start,
						$temp$txt = txt;
					idxs = $temp$idxs;
					start = $temp$start;
					txt = $temp$txt;
					continue componentsHelp;
				}
			}
		}
	});
var author$project$Destructuring$components = function (txt) {
	return A3(
		author$project$Destructuring$componentsHelp,
		A2(elm$core$String$indices, ' ', txt),
		0,
		txt);
};
var author$project$Destructuring$deunionHelp = function (txt) {
	var _n0 = elm$core$String$words(
		elm$core$String$trim(txt));
	if (_n0.b) {
		var x = _n0.a;
		var ys = _n0.b;
		return elm$core$Maybe$Just(
			_Utils_Tuple2(
				x,
				author$project$Destructuring$components(
					A2(
						author$project$Destructuring$dropWord,
						x,
						elm$core$String$trim(txt)))));
	} else {
		return elm$core$Maybe$Nothing;
	}
};
var author$project$Destructuring$deunion = function (txt) {
	return author$project$Destructuring$removeNothings(
		A2(
			elm$core$List$map,
			author$project$Destructuring$deunionHelp,
			A2(
				elm$core$String$split,
				'|',
				author$project$Destructuring$singleSpace(txt))));
};
var author$project$Types$TypeBool = {$: 1};
var author$project$Types$TypeDef = F2(
	function (name, theType) {
		return {ag: name, ao: theType};
	});
var author$project$Types$TypeError = function (a) {
	return {$: 3, a: a};
};
var author$project$Types$TypeFloat = {$: 6};
var author$project$Types$TypeImported = function (a) {
	return {$: 7, a: a};
};
var author$project$Types$TypeInt = {$: 8};
var author$project$Types$TypeProduct = function (a) {
	return {$: 11, a: a};
};
var author$project$Types$TypeString = {$: 13};
var author$project$ParseType$typeOf = F2(
	function (extensible, def) {
		var subType = function (x) {
			return A2(author$project$ParseType$typeOf, false, x);
		};
		var _n0 = author$project$Destructuring$detuple(def);
		if (_n0.b) {
			var a = _n0.a;
			var bs = _n0.b;
			return author$project$Types$TypeTuple(
				A2(
					elm$core$List$map,
					subType,
					A2(elm$core$List$cons, a, bs)));
		} else {
			var _n1 = author$project$Destructuring$derecord(def);
			if (_n1.b) {
				var _n2 = _n1.a;
				var a1 = _n2.a;
				var a2 = _n2.b;
				var bs = _n1.b;
				var makeField = function (_n5) {
					var x = _n5.a;
					var y = _n5.b;
					return A2(
						author$project$Types$TypeDef,
						x,
						subType(y));
				};
				var fields = function () {
					var _n4 = a1 === '';
					if (_n4) {
						return _List_Nil;
					} else {
						return A2(
							elm$core$List$map,
							makeField,
							A2(
								elm$core$List$cons,
								_Utils_Tuple2(a1, a2),
								bs));
					}
				}();
				if (extensible) {
					return author$project$Types$TypeExtensible(fields);
				} else {
					return author$project$Types$TypeRecord(fields);
				}
			} else {
				var _n6 = elm$core$String$words(
					author$project$Destructuring$debracket(def));
				if (!_n6.b) {
					return author$project$Types$TypeError('Type conversion error: empty string');
				} else {
					var a = _n6.a;
					var bs = _n6.b;
					switch (a) {
						case 'Array':
							return author$project$Types$TypeArray(
								subType(
									A2(
										author$project$Destructuring$dropWord,
										a,
										author$project$Destructuring$debracket(def))));
						case 'Bool':
							return author$project$Types$TypeBool;
						case 'Dict':
							var _n8 = author$project$Destructuring$deunion(
								author$project$Destructuring$debracket(def));
							if ((_n8.b && _n8.a.b.b) && _n8.a.b.b.b) {
								var _n9 = _n8.a;
								var _n10 = _n9.b;
								var c = _n10.a;
								var _n11 = _n10.b;
								var d = _n11.a;
								var es = _n11.b;
								var fs = _n8.b;
								return author$project$Types$TypeDict(
									_Utils_Tuple2(
										subType(c),
										subType(d)));
							} else {
								return author$project$Types$TypeError('Error parsing def as a Dict');
							}
						case 'Dict.Dict':
							var _n12 = author$project$Destructuring$deunion(
								author$project$Destructuring$debracket(def));
							if ((_n12.b && _n12.a.b.b) && _n12.a.b.b.b) {
								var _n13 = _n12.a;
								var _n14 = _n13.b;
								var c = _n14.a;
								var _n15 = _n14.b;
								var d = _n15.a;
								var es = _n15.b;
								var fs = _n12.b;
								return author$project$Types$TypeDict(
									_Utils_Tuple2(
										subType(c),
										subType(d)));
							} else {
								return author$project$Types$TypeError('Error parsing def as a Dict');
							}
						case 'Float':
							return author$project$Types$TypeFloat;
						case 'Int':
							return author$project$Types$TypeInt;
						case 'List':
							return author$project$Types$TypeList(
								subType(
									A2(
										author$project$Destructuring$dropWord,
										a,
										author$project$Destructuring$debracket(def))));
						case 'Maybe':
							return author$project$Types$TypeMaybe(
								subType(
									A2(
										author$project$Destructuring$dropWord,
										a,
										author$project$Destructuring$debracket(def))));
						case 'String':
							return author$project$Types$TypeString;
						default:
							var constructor = function (_n20) {
								var x = _n20.a;
								var y = _n20.b;
								if ((y.b && (y.a === '')) && (!y.b.b)) {
									return _Utils_Tuple2(x, _List_Nil);
								} else {
									return _Utils_Tuple2(
										x,
										A2(elm$core$List$map, subType, y));
								}
							};
							var _n16 = author$project$Destructuring$deunion(def);
							if (_n16.b) {
								if (!_n16.b.b) {
									var _n17 = _n16.a;
									var x = _n17.a;
									var y = _n17.b;
									if ((y.b && (y.a === '')) && (!y.b.b)) {
										return author$project$Types$TypeImported(x);
									} else {
										return author$project$Types$TypeProduct(
											_Utils_Tuple2(
												x,
												A2(elm$core$List$map, subType, y)));
									}
								} else {
									var c = _n16.a;
									var ds = _n16.b;
									return author$project$Types$TypeUnion(
										A2(
											elm$core$List$map,
											constructor,
											A2(elm$core$List$cons, c, ds)));
								}
							} else {
								return author$project$Types$TypeError('Union type conversion error: empty');
							}
					}
				}
			}
		}
	});
var author$project$ParseType$grabTypeDefs = function (txt) {
	var toTypeDef = function (a) {
		return {
			ag: a.ag,
			ao: A2(author$project$ParseType$typeOf, a.ae, a.ac)
		};
	};
	return A2(
		elm$core$List$map,
		toTypeDef,
		author$project$ParseType$grabRawTypes(txt));
};
var author$project$ParseType$extractBasic = F2(
	function (encoding, txt) {
		var declared = author$project$ParseType$grabTypeDefs(txt);
		return A2(
			elm$core$List$map,
			author$project$ParseType$detectExtendedRecord(declared),
			declared);
	});
var author$project$ParseType$extractHelp = F2(
	function (encoding, txt) {
		var scannedDeclared = A2(author$project$ParseType$extractBasic, encoding, txt);
		var anonymous = A2(author$project$ParseType$anonymousTypes, encoding, scannedDeclared);
		return _Utils_Tuple2(scannedDeclared, anonymous);
	});
var author$project$Types$isEmptyRecord = function (_this) {
	var _n0 = _this.ao;
	if ((_n0.$ === 12) && (!_n0.a.b)) {
		return true;
	} else {
		return false;
	}
};
var author$project$Types$isExtensible = function (_this) {
	var _n0 = _this.ao;
	if (_n0.$ === 5) {
		return true;
	} else {
		return false;
	}
};
var author$project$Types$isNonemptyExtended = function (_this) {
	var _n0 = _this.ao;
	if (_n0.$ === 4) {
		if (!_n0.a.b) {
			return false;
		} else {
			return true;
		}
	} else {
		return false;
	}
};
var author$project$Types$isRecord = function (_this) {
	var _n0 = _this.ao;
	if (_n0.$ === 12) {
		return true;
	} else {
		return false;
	}
};
var author$project$ParseType$extractAllWithDefs = F2(
	function (encoding, txt) {
		var nonEmptyRecord = function (a) {
			return author$project$Types$isRecord(a) && (!author$project$Types$isEmptyRecord(a));
		};
		var _n0 = A2(author$project$ParseType$extractHelp, encoding, txt);
		var declared = _n0.a;
		var anonymous = _n0.b;
		var filtered = A2(
			elm$core$List$filter,
			A2(elm$core$Basics$composeL, elm$core$Basics$not, author$project$Types$isExtensible),
			_Utils_ap(declared, anonymous));
		var needToDefine = _Utils_ap(
			A2(elm$core$List$filter, nonEmptyRecord, anonymous),
			A2(
				elm$core$List$filter,
				author$project$Types$isNonemptyExtended,
				_Utils_ap(declared, anonymous)));
		return _Utils_Tuple2(
			filtered,
			author$project$ParseType$aliasDefs(needToDefine));
	});
var elm$core$List$sortBy = _List_sortBy;
var author$project$Generate$decoders = F2(
	function (extra, txt) {
		var _n0 = A2(author$project$ParseType$extractAllWithDefs, false, txt);
		var allTypes = _n0.a;
		var anonymousDefs = _n0.b;
		return author$project$Destructuring$stringify(
			_Utils_ap(
				anonymousDefs,
				A2(
					elm$core$List$map,
					author$project$Decoder$decoder(extra),
					A2(
						elm$core$List$sortBy,
						function ($) {
							return $.ag;
						},
						allTypes))));
	});
var elm$core$List$repeatHelp = F3(
	function (result, n, value) {
		repeatHelp:
		while (true) {
			if (n <= 0) {
				return result;
			} else {
				var $temp$result = A2(elm$core$List$cons, value, result),
					$temp$n = n - 1,
					$temp$value = value;
				result = $temp$result;
				n = $temp$n;
				value = $temp$value;
				continue repeatHelp;
			}
		}
	});
var elm$core$List$repeat = F2(
	function (n, value) {
		return A3(elm$core$List$repeatHelp, _List_Nil, n, value);
	});
var author$project$Destructuring$bracketCommas = function (xs) {
	var separators = A2(
		elm$core$List$cons,
		'[',
		A2(
			elm$core$List$repeat,
			elm$core$List$length(xs) - 1,
			','));
	var glue = F2(
		function (a, b) {
			return a + (' ' + b);
		});
	return A3(elm$core$List$map2, glue, separators, xs);
};
var author$project$Encoder$var = function (n) {
	return 'a' + elm$core$String$fromInt(n);
};
var author$project$Encoder$varUpper = function (n) {
	return 'A' + elm$core$String$fromInt(n);
};
var author$project$Encoder$encoderDict = F2(
	function (name, _n31) {
		var b = _n31.a;
		var c = _n31.b;
		var subEncoderName = 'encode' + (author$project$Destructuring$replaceColons(name) + 'Tuple');
		return A2(
			elm$core$String$join,
			'\n',
			_List_fromArray(
				[
					'let',
					A2(author$project$Destructuring$tab, 1, subEncoderName + ' (a1,a2) ='),
					A2(author$project$Destructuring$tab, 2, 'Encode.object'),
					A2(
					author$project$Destructuring$tab,
					3,
					'[ (\"A1\", ' + (author$project$Destructuring$bracketIfSpaced(
						A3(author$project$Encoder$encoderHelp, false, '', b)) + ' a1)')),
					A2(
					author$project$Destructuring$tab,
					3,
					', (\"A2\", ' + (author$project$Destructuring$bracketIfSpaced(
						A3(author$project$Encoder$encoderHelp, false, '', c)) + ' a2) ]')),
					'in',
					A2(author$project$Destructuring$tab, 1, '(Encode.list ' + (subEncoderName + ') (Dict.toList a)'))
				]));
	});
var author$project$Encoder$encoderHelp = F3(
	function (topLevel, rawName, a) {
		var recurseOn = F2(
			function (x, y) {
				return x + (' ' + author$project$Destructuring$bracketIfSpaced(
					A3(author$project$Encoder$encoderHelp, false, '', y)));
			});
		var name = author$project$Destructuring$replaceColons(rawName);
		var maybeAppend = function (txt) {
			if (topLevel) {
				return author$project$Destructuring$bracketIfSpaced(txt) + ' a';
			} else {
				return txt;
			}
		};
		switch (a.$) {
			case 0:
				var b = a.a;
				return maybeAppend(
					A2(recurseOn, 'Encode.array', b));
			case 1:
				return maybeAppend('Encode.bool');
			case 2:
				var _n13 = a.a;
				var b = _n13.a;
				var c = _n13.b;
				if (topLevel) {
					return A2(
						author$project$Encoder$encoderDict,
						name,
						_Utils_Tuple2(b, c));
				} else {
					if (name === '') {
						return 'encode' + author$project$Destructuring$replaceColons(
							author$project$ParseType$typeNick(a));
					} else {
						return 'encode' + name;
					}
				}
			case 3:
				var b = a.a;
				return maybeAppend(b);
			case 4:
				var b = a.a;
				if (topLevel) {
					return author$project$Encoder$encoderRecord(b);
				} else {
					if (name === '') {
						return 'encode' + author$project$ParseType$typeNick(a);
					} else {
						return 'encode' + name;
					}
				}
			case 5:
				var b = a.a;
				return maybeAppend('<< Extensible records cannot be encoded >>');
			case 6:
				return maybeAppend('Encode.float');
			case 7:
				var importedTypeReference = a.a;
				var _n18 = elm$core$List$reverse(
					A2(elm$core$String$split, '.', importedTypeReference));
				if (_n18.b) {
					var typeName = _n18.a;
					var reversedPath = _n18.b;
					var path = function () {
						if (!reversedPath.b) {
							return '';
						} else {
							return A2(
								elm$core$String$join,
								'.',
								elm$core$List$reverse(reversedPath)) + '.';
						}
					}();
					return path + ('encode' + (typeName + (topLevel ? ' a' : '')));
				} else {
					return 'encode' + (name + ' a =');
				}
			case 8:
				return maybeAppend('Encode.int');
			case 9:
				var b = a.a;
				return maybeAppend(
					A2(recurseOn, 'Encode.list', b));
			case 10:
				var b = a.a;
				if (topLevel) {
					return author$project$Encoder$encoderMaybe(b);
				} else {
					if (name === '') {
						return 'encode' + author$project$ParseType$typeNick(a);
					} else {
						return 'encode' + name;
					}
				}
			case 11:
				var b = a.a;
				if (topLevel) {
					return A3(author$project$Encoder$encoderProduct, true, false, b);
				} else {
					if (name === '') {
						return 'encode' + author$project$ParseType$typeNick(a);
					} else {
						return 'encode' + name;
					}
				}
			case 12:
				var b = a.a;
				if (topLevel) {
					return author$project$Encoder$encoderRecord(b);
				} else {
					if (name === '') {
						return 'encode' + author$project$ParseType$typeNick(a);
					} else {
						return 'encode' + name;
					}
				}
			case 13:
				return maybeAppend('Encode.string');
			case 14:
				var bs = a.a;
				if (topLevel) {
					return author$project$Encoder$encoderTuple(bs);
				} else {
					if (name === '') {
						return 'encode' + author$project$ParseType$typeNick(a);
					} else {
						return 'encode' + name;
					}
				}
			default:
				var b = a.a;
				if (topLevel) {
					return author$project$Encoder$encoderUnion(b);
				} else {
					if (name === '') {
						var folder = F2(
							function (x, y) {
								return x + (', ' + y);
							});
						var typeStr = '{ ' + (A3(
							elm$core$List$foldl,
							folder,
							'',
							A2(elm$core$List$map, elm$core$Tuple$first, b)) + ' }');
						return 'Encoder parse error: unanymous union type: ' + typeStr;
					} else {
						return 'encode' + name;
					}
				}
		}
	});
var author$project$Encoder$encoderMaybe = function (x) {
	return A2(
		elm$core$String$join,
		'\n',
		_List_fromArray(
			[
				'case a of',
				A2(author$project$Destructuring$tab, 1, 'Just b->'),
				A2(
				author$project$Destructuring$tab,
				2,
				author$project$Destructuring$bracketIfSpaced(
					A3(author$project$Encoder$encoderHelp, false, '', x)) + ' b'),
				A2(author$project$Destructuring$tab, 1, 'Nothing->'),
				A2(author$project$Destructuring$tab, 2, 'Encode.null')
			]));
};
var author$project$Encoder$encoderProduct = F3(
	function (productType, addConstructor, _n5) {
		var constructor = _n5.a;
		var subTypes = _n5.b;
		var vars = A2(
			elm$core$List$map,
			author$project$Encoder$var,
			A2(
				elm$core$List$range,
				1,
				elm$core$List$length(subTypes)));
		var subEncoder = function (a) {
			var fullEncoder = A2(
				elm$core$String$dropRight,
				2,
				A3(author$project$Encoder$encoderHelp, true, '', a));
			var _n11 = author$project$Types$coreTypeForEncoding(a);
			if (_n11) {
				return fullEncoder;
			} else {
				return author$project$Destructuring$bracketIfSpaced(
					A3(author$project$Encoder$encoderHelp, false, '', a));
			}
		};
		var fieldEncode = function (_n10) {
			var a = _n10.a;
			var b = _n10.b;
			return '(' + (author$project$Destructuring$quote(
				author$project$Destructuring$capitalize(a)) + (', ' + (subEncoder(b) + (' ' + (a + ')')))));
		};
		var fieldDefs = A3(
			elm$core$List$map2,
			F2(
				function (a, b) {
					return _Utils_Tuple2(a, b);
				}),
			vars,
			subTypes);
		var constrEncode = function () {
			if (!addConstructor) {
				return _List_Nil;
			} else {
				return _List_fromArray(
					[
						'(\"Constructor\", Encode.string ' + (author$project$Destructuring$quote(constructor) + ')')
					]);
			}
		}();
		var defaultEncoder = A2(
			elm$core$String$join,
			'\n',
			_Utils_ap(
				_List_fromArray(
					['Encode.object']),
				_Utils_ap(
					A2(
						elm$core$List$map,
						author$project$Destructuring$tab(1),
						author$project$Destructuring$bracketCommas(
							_Utils_ap(
								constrEncode,
								A2(elm$core$List$map, fieldEncode, fieldDefs)))),
					_List_fromArray(
						[
							A2(author$project$Destructuring$tab, 1, ']')
						]))));
		if (!subTypes.b) {
			if (addConstructor) {
				return defaultEncoder;
			} else {
				return 'Encode.string ' + author$project$Destructuring$quote(constructor);
			}
		} else {
			if (!subTypes.b.b) {
				var x = subTypes.a;
				if (productType) {
					return subEncoder(x) + ' a1';
				} else {
					return defaultEncoder;
				}
			} else {
				return defaultEncoder;
			}
		}
	});
var author$project$Encoder$encoderRecord = function (xs) {
	var subEncoder = function (x) {
		return author$project$Destructuring$bracketIfSpaced(
			A3(author$project$Encoder$encoderHelp, false, '', x));
	};
	var fieldEncode = function (x) {
		return '(' + (author$project$Destructuring$quote(
			author$project$Destructuring$replaceColons(x.ag)) + (', ' + (subEncoder(x.ao) + (' a.' + (author$project$Destructuring$replaceColons(x.ag) + ')')))));
	};
	return A2(
		elm$core$String$join,
		'\n',
		_Utils_ap(
			_List_fromArray(
				['Encode.object']),
			_Utils_ap(
				A2(
					elm$core$List$map,
					author$project$Destructuring$tab(1),
					author$project$Destructuring$bracketCommas(
						A2(elm$core$List$map, fieldEncode, xs))),
				_List_fromArray(
					[
						A2(author$project$Destructuring$tab, 1, ']')
					]))));
};
var author$project$Encoder$encoderTuple = function (xs) {
	var encodeElement = function (_n4) {
		var idx = _n4.a;
		var elem = _n4.b;
		return '(\"' + (author$project$Encoder$varUpper(idx + 1) + ('\", ' + (author$project$Destructuring$bracketIfSpaced(
			A3(author$project$Encoder$encoderHelp, false, '', elem)) + (' ' + (author$project$Encoder$var(idx + 1) + ')')))));
	};
	return A2(
		elm$core$String$join,
		'\n',
		_Utils_ap(
			_List_fromArray(
				['Encode.object']),
			_Utils_ap(
				A2(
					elm$core$List$map,
					author$project$Destructuring$tab(1),
					author$project$Destructuring$bracketCommas(
						A2(
							elm$core$List$map,
							encodeElement,
							A2(elm$core$List$indexedMap, elm$core$Tuple$pair, xs)))),
				_List_fromArray(
					[
						A2(author$project$Destructuring$tab, 1, ']')
					]))));
};
var author$project$Encoder$encoderUnion = function (xs) {
	var complexConstructor = function (_n3) {
		var a = _n3.a;
		var b = _n3.b;
		return !_Utils_eq(b, _List_Nil);
	};
	var simpleUnion = _Utils_eq(
		A2(elm$core$List$filter, complexConstructor, xs),
		_List_Nil);
	if (simpleUnion) {
		return author$project$Encoder$encoderUnionSimple(xs);
	} else {
		return author$project$Encoder$encoderUnionComplex(xs);
	}
};
var author$project$Encoder$encoderUnionComplex = function (xs) {
	var varList = function (ys) {
		return A2(
			elm$core$String$join,
			' ',
			A2(
				elm$core$List$map,
				author$project$Encoder$var,
				A2(
					elm$core$List$range,
					1,
					elm$core$List$length(ys))));
	};
	var encodeConstructor = function (_n1) {
		var a = _n1.a;
		var ys = _n1.b;
		return _Utils_ap(
			A2(
				author$project$Destructuring$tab,
				1,
				a + (' ' + (varList(ys) + ('->' + '\n')))),
			A2(
				author$project$Destructuring$tabLines,
				2,
				A3(
					author$project$Encoder$encoderProduct,
					false,
					true,
					_Utils_Tuple2(a, ys))));
	};
	return A2(
		elm$core$String$join,
		'\n',
		_Utils_ap(
			_List_fromArray(
				['case a of']),
			A2(elm$core$List$map, encodeConstructor, xs)));
};
var author$project$Encoder$encoderUnionSimple = function (xs) {
	var encodeConstructor = function (_n0) {
		var a = _n0.a;
		var ys = _n0.b;
		return _Utils_ap(
			A2(author$project$Destructuring$tab, 1, a + (' ->' + '\n')),
			A2(
				author$project$Destructuring$tabLines,
				2,
				A3(
					author$project$Encoder$encoderProduct,
					false,
					false,
					_Utils_Tuple2(a, ys))));
	};
	return A2(
		elm$core$String$join,
		'\n',
		_Utils_ap(
			_List_fromArray(
				['case a of']),
			A2(elm$core$List$map, encodeConstructor, xs)));
};
var author$project$Encoder$encoder = function (typeDef) {
	var vars = function (a) {
		return A2(
			elm$core$List$map,
			author$project$Encoder$var,
			A2(
				elm$core$List$range,
				1,
				elm$core$List$length(a)));
	};
	var varListComma = function (a) {
		return A2(
			elm$core$String$join,
			', ',
			vars(a));
	};
	var varList = function (a) {
		return A2(
			elm$core$String$join,
			' ',
			vars(a));
	};
	var name = author$project$Destructuring$replaceColons(typeDef.ag);
	var encoderName = function () {
		var _n0 = typeDef.ao;
		switch (_n0.$) {
			case 14:
				var xs = _n0.a;
				return 'encode' + (name + (' (' + (varListComma(xs) + ') =')));
			case 11:
				var _n1 = _n0.a;
				var b = _n1.a;
				var c = _n1.b;
				if (!c.b) {
					return 'encode' + (name + ' a =');
				} else {
					return 'encode' + (name + (' (' + (b + (' ' + (varList(c) + ') =')))));
				}
			default:
				return 'encode' + (name + ' a =');
		}
	}();
	var encoderBody = A2(
		elm$core$List$map,
		author$project$Destructuring$tab(1),
		A2(
			elm$core$String$split,
			'\n',
			A3(author$project$Encoder$encoderHelp, true, typeDef.ag, typeDef.ao)));
	return A2(elm$core$List$cons, encoderName, encoderBody);
};
var author$project$ParseType$extractAll = F2(
	function (encoding, txt) {
		var _n0 = A2(author$project$ParseType$extractHelp, encoding, txt);
		var declared = _n0.a;
		var anonymous = _n0.b;
		return A2(
			elm$core$List$filter,
			A2(elm$core$Basics$composeL, elm$core$Basics$not, author$project$Types$isExtensible),
			_Utils_ap(declared, anonymous));
	});
var author$project$Generate$encoders = function (txt) {
	var allTypes = A2(author$project$ParseType$extractAll, true, txt);
	return author$project$Destructuring$stringify(
		A2(
			elm$core$List$map,
			author$project$Encoder$encoder,
			A2(
				elm$core$List$sortBy,
				function ($) {
					return $.ag;
				},
				allTypes)));
};
var author$project$Generate$both = F2(
	function (extra, txt) {
		return A2(author$project$Generate$decoders, extra, txt) + ('\n\n' + author$project$Generate$encoders(txt));
	});
var author$project$Types$Extra = 0;
var author$project$Cli$run = function (sourceCodes) {
	var coders = A2(author$project$Generate$both, 0, sourceCodes);
	return _Utils_Tuple2(
		{},
		author$project$Cli$done(coders));
};
var elm$core$Basics$always = F2(
	function (a, _n0) {
		return a;
	});
var elm$core$Platform$worker = _Platform_worker;
var elm$core$Platform$Cmd$batch = _Platform_batch;
var elm$core$Platform$Cmd$none = elm$core$Platform$Cmd$batch(_List_Nil);
var elm$core$Platform$Sub$batch = _Platform_batch;
var elm$core$Platform$Sub$none = elm$core$Platform$Sub$batch(_List_Nil);
var elm$json$Json$Decode$string = _Json_decodeString;
var author$project$Cli$main = elm$core$Platform$worker(
	{
		bz: author$project$Cli$run,
		bS: elm$core$Basics$always(elm$core$Platform$Sub$none),
		bW: elm$core$Basics$always(
			elm$core$Basics$always(
				_Utils_Tuple2(
					{},
					elm$core$Platform$Cmd$none)))
	});
_Platform_export({'Cli':{'init':author$project$Cli$main(elm$json$Json$Decode$string)(0)}});}(this));